#ifndef TRACE_H
#define TRACE_H

/* This file is autogenerated by tracetool, do not edit. */

#include "qemu-common.h"
#include "trace-dtrace.h"

static inline void trace_g_malloc(size_t size, void *ptr) {
    if (QEMU_G_MALLOC_ENABLED()) {
        QEMU_G_MALLOC(size, ptr);
    }
}

static inline void trace_g_realloc(void *ptr, size_t size, void *newptr) {
    if (QEMU_G_REALLOC_ENABLED()) {
        QEMU_G_REALLOC(ptr, size, newptr);
    }
}

static inline void trace_g_free(void *ptr) {
    if (QEMU_G_FREE_ENABLED()) {
        QEMU_G_FREE(ptr);
    }
}

static inline void trace_qemu_memalign(size_t alignment, size_t size, void *ptr) {
    if (QEMU_QEMU_MEMALIGN_ENABLED()) {
        QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    }
}

static inline void trace_qemu_vmalloc(size_t size, void *ptr) {
    if (QEMU_QEMU_VMALLOC_ENABLED()) {
        QEMU_QEMU_VMALLOC(size, ptr);
    }
}

static inline void trace_qemu_vfree(void *ptr) {
    if (QEMU_QEMU_VFREE_ENABLED()) {
        QEMU_QEMU_VFREE(ptr);
    }
}

static inline void trace_virtqueue_fill(void *vq, const void *elem, unsigned int len, unsigned int idx) {
    if (QEMU_VIRTQUEUE_FILL_ENABLED()) {
        QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void *vq, unsigned int count) {
    if (QEMU_VIRTQUEUE_FLUSH_ENABLED()) {
        QEMU_VIRTQUEUE_FLUSH(vq, count);
    }
}

static inline void trace_virtqueue_pop(void *vq, void *elem, unsigned int in_num, unsigned int out_num) {
    if (QEMU_VIRTQUEUE_POP_ENABLED()) {
        QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void *vdev, int n, void *vq) {
    if (QEMU_VIRTIO_QUEUE_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void *vq) {
    if (QEMU_VIRTIO_IRQ_ENABLED()) {
        QEMU_VIRTIO_IRQ(vq);
    }
}

static inline void trace_virtio_notify(void *vdev, void *vq) {
    if (QEMU_VIRTIO_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_NOTIFY(vdev, vq);
    }
}

static inline void trace_virtio_set_status(void *vdev, uint8_t val) {
    if (QEMU_VIRTIO_SET_STATUS_ENABLED()) {
        QEMU_VIRTIO_SET_STATUS(vdev, val);
    }
}

static inline void trace_virtio_serial_send_control_event(unsigned int port, uint16_t event, uint16_t value) {
    if (QEMU_VIRTIO_SERIAL_SEND_CONTROL_EVENT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_SEND_CONTROL_EVENT(port, event, value);
    }
}

static inline void trace_virtio_serial_throttle_port(unsigned int port, bool throttle) {
    if (QEMU_VIRTIO_SERIAL_THROTTLE_PORT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_THROTTLE_PORT(port, throttle);
    }
}

static inline void trace_virtio_serial_handle_control_message(uint16_t event, uint16_t value) {
    if (QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_ENABLED()) {
        QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE(event, value);
    }
}

static inline void trace_virtio_serial_handle_control_message_port(unsigned int port) {
    if (QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT(port);
    }
}

static inline void trace_virtio_console_flush_buf(unsigned int port, size_t len, ssize_t ret) {
    if (QEMU_VIRTIO_CONSOLE_FLUSH_BUF_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_FLUSH_BUF(port, len, ret);
    }
}

static inline void trace_virtio_console_chr_read(unsigned int port, int size) {
    if (QEMU_VIRTIO_CONSOLE_CHR_READ_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_READ(port, size);
    }
}

static inline void trace_virtio_console_chr_event(unsigned int port, int event) {
    if (QEMU_VIRTIO_CONSOLE_CHR_EVENT_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_EVENT(port, event);
    }
}

static inline void trace_bdrv_open_common(void *bs, const char *filename, int flags, const char *format_name) {
    if (QEMU_BDRV_OPEN_COMMON_ENABLED()) {
        QEMU_BDRV_OPEN_COMMON(bs, filename, flags, format_name);
    }
}

static inline void trace_multiwrite_cb(void *mcb, int ret) {
    if (QEMU_MULTIWRITE_CB_ENABLED()) {
        QEMU_MULTIWRITE_CB(mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void *mcb, int num_callbacks, int num_reqs) {
    if (QEMU_BDRV_AIO_MULTIWRITE_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_multiwrite_earlyfail(void *mcb) {
    if (QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL(mcb);
    }
}

static inline void trace_bdrv_aio_multiwrite_latefail(void *mcb, int i) {
    if (QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL(mcb, i);
    }
}

static inline void trace_bdrv_aio_discard(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_DISCARD_ENABLED()) {
        QEMU_BDRV_AIO_DISCARD(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_flush(void *bs, void *opaque) {
    if (QEMU_BDRV_AIO_FLUSH_ENABLED()) {
        QEMU_BDRV_AIO_FLUSH(bs, opaque);
    }
}

static inline void trace_bdrv_aio_readv(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_READV_ENABLED()) {
        QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_WRITEV_ENABLED()) {
        QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_lock_medium(void *bs, bool locked) {
    if (QEMU_BDRV_LOCK_MEDIUM_ENABLED()) {
        QEMU_BDRV_LOCK_MEDIUM(bs, locked);
    }
}

static inline void trace_bdrv_co_readv(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_READV_ENABLED()) {
        QEMU_BDRV_CO_READV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_writev(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_WRITEV_ENABLED()) {
        QEMU_BDRV_CO_WRITEV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_io_em(void *bs, int64_t sector_num, int nb_sectors, int is_write, void *acb) {
    if (QEMU_BDRV_CO_IO_EM_ENABLED()) {
        QEMU_BDRV_CO_IO_EM(bs, sector_num, nb_sectors, is_write, acb);
    }
}

static inline void trace_virtio_blk_req_complete(void *req, int status) {
    if (QEMU_VIRTIO_BLK_REQ_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void *req, int ret) {
    if (QEMU_VIRTIO_BLK_RW_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void *req, uint64_t sector, size_t nsectors) {
    if (QEMU_VIRTIO_BLK_HANDLE_WRITE_ENABLED()) {
        QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    }
}

static inline void trace_paio_submit(void *acb, void *opaque, int64_t sector_num, int nb_sectors, int type) {
    if (QEMU_PAIO_SUBMIT_ENABLED()) {
        QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_paio_complete(void *acb, void *opaque, int ret) {
    if (QEMU_PAIO_COMPLETE_ENABLED()) {
        QEMU_PAIO_COMPLETE(acb, opaque, ret);
    }
}

static inline void trace_paio_cancel(void *acb, void *opaque) {
    if (QEMU_PAIO_CANCEL_ENABLED()) {
        QEMU_PAIO_CANCEL(acb, opaque);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_IN_ENABLED()) {
        QEMU_CPU_IN(addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_OUT_ENABLED()) {
        QEMU_CPU_OUT(addr, val);
    }
}

static inline void trace_balloon_event(void *opaque, unsigned long addr) {
    if (QEMU_BALLOON_EVENT_ENABLED()) {
        QEMU_BALLOON_EVENT(opaque, addr);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt) {
    if (QEMU_APIC_LOCAL_DELIVER_ENABLED()) {
        QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t trigger_mode) {
    if (QEMU_APIC_DELIVER_IRQ_ENABLED()) {
        QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, trigger_mode);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val) {
    if (QEMU_CPU_SET_APIC_BASE_ENABLED()) {
        QEMU_CPU_SET_APIC_BASE(val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val) {
    if (QEMU_CPU_GET_APIC_BASE_ENABLED()) {
        QEMU_CPU_GET_APIC_BASE(val);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_READL_ENABLED()) {
        QEMU_APIC_MEM_READL(addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_WRITEL_ENABLED()) {
        QEMU_APIC_MEM_WRITEL(addr, val);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_RESET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_GET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_set_irq(int apic_irq_delivered) {
    if (QEMU_APIC_SET_IRQ_ENABLED()) {
        QEMU_APIC_SET_IRQ(apic_irq_delivered);
    }
}

static inline void trace_cs4231_mem_readl_dreg(uint32_t reg, uint32_t ret) {
    if (QEMU_CS4231_MEM_READL_DREG_ENABLED()) {
        QEMU_CS4231_MEM_READL_DREG(reg, ret);
    }
}

static inline void trace_cs4231_mem_readl_reg(uint32_t reg, uint32_t ret) {
    if (QEMU_CS4231_MEM_READL_REG_ENABLED()) {
        QEMU_CS4231_MEM_READL_REG(reg, ret);
    }
}

static inline void trace_cs4231_mem_writel_reg(uint32_t reg, uint32_t old, uint32_t val) {
    if (QEMU_CS4231_MEM_WRITEL_REG_ENABLED()) {
        QEMU_CS4231_MEM_WRITEL_REG(reg, old, val);
    }
}

static inline void trace_cs4231_mem_writel_dreg(uint32_t reg, uint32_t old, uint32_t val) {
    if (QEMU_CS4231_MEM_WRITEL_DREG_ENABLED()) {
        QEMU_CS4231_MEM_WRITEL_DREG(reg, old, val);
    }
}

static inline void trace_nvram_read(uint32_t addr, uint32_t ret) {
    if (QEMU_NVRAM_READ_ENABLED()) {
        QEMU_NVRAM_READ(addr, ret);
    }
}

static inline void trace_nvram_write(uint32_t addr, uint32_t old, uint32_t val) {
    if (QEMU_NVRAM_WRITE_ENABLED()) {
        QEMU_NVRAM_WRITE(addr, old, val);
    }
}

static inline void trace_ecc_mem_writel_mer(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MER_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MER(val);
    }
}

static inline void trace_ecc_mem_writel_mdr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MDR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MDR(val);
    }
}

static inline void trace_ecc_mem_writel_mfsr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MFSR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MFSR(val);
    }
}

static inline void trace_ecc_mem_writel_vcr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_VCR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_VCR(val);
    }
}

static inline void trace_ecc_mem_writel_dr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_DR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_DR(val);
    }
}

static inline void trace_ecc_mem_writel_ecr0(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_ECR0_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_ECR0(val);
    }
}

static inline void trace_ecc_mem_writel_ecr1(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_ECR1_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_ECR1(val);
    }
}

static inline void trace_ecc_mem_readl_mer(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MER_ENABLED()) {
        QEMU_ECC_MEM_READL_MER(ret);
    }
}

static inline void trace_ecc_mem_readl_mdr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MDR_ENABLED()) {
        QEMU_ECC_MEM_READL_MDR(ret);
    }
}

static inline void trace_ecc_mem_readl_mfsr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFSR_ENABLED()) {
        QEMU_ECC_MEM_READL_MFSR(ret);
    }
}

static inline void trace_ecc_mem_readl_vcr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_VCR_ENABLED()) {
        QEMU_ECC_MEM_READL_VCR(ret);
    }
}

static inline void trace_ecc_mem_readl_mfar0(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFAR0_ENABLED()) {
        QEMU_ECC_MEM_READL_MFAR0(ret);
    }
}

static inline void trace_ecc_mem_readl_mfar1(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFAR1_ENABLED()) {
        QEMU_ECC_MEM_READL_MFAR1(ret);
    }
}

static inline void trace_ecc_mem_readl_dr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_DR_ENABLED()) {
        QEMU_ECC_MEM_READL_DR(ret);
    }
}

static inline void trace_ecc_mem_readl_ecr0(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_ECR0_ENABLED()) {
        QEMU_ECC_MEM_READL_ECR0(ret);
    }
}

static inline void trace_ecc_mem_readl_ecr1(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_ECR1_ENABLED()) {
        QEMU_ECC_MEM_READL_ECR1(ret);
    }
}

static inline void trace_ecc_diag_mem_writeb(uint64_t addr, uint32_t val) {
    if (QEMU_ECC_DIAG_MEM_WRITEB_ENABLED()) {
        QEMU_ECC_DIAG_MEM_WRITEB(addr, val);
    }
}

static inline void trace_ecc_diag_mem_readb(uint64_t addr, uint32_t ret) {
    if (QEMU_ECC_DIAG_MEM_READB_ENABLED()) {
        QEMU_ECC_DIAG_MEM_READB(addr, ret);
    }
}

static inline void trace_lance_mem_readw(uint64_t addr, uint32_t ret) {
    if (QEMU_LANCE_MEM_READW_ENABLED()) {
        QEMU_LANCE_MEM_READW(addr, ret);
    }
}

static inline void trace_lance_mem_writew(uint64_t addr, uint32_t val) {
    if (QEMU_LANCE_MEM_WRITEW_ENABLED()) {
        QEMU_LANCE_MEM_WRITEW(addr, val);
    }
}

static inline void trace_slavio_intctl_mem_readl(uint32_t cpu, uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_INTCTL_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_READL(cpu, addr, ret);
    }
}

static inline void trace_slavio_intctl_mem_writel(uint32_t cpu, uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL(cpu, addr, val);
    }
}

static inline void trace_slavio_intctl_mem_writel_clear(uint32_t cpu, uint32_t val, uint32_t intreg_pending) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_CLEAR_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL_CLEAR(cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctl_mem_writel_set(uint32_t cpu, uint32_t val, uint32_t intreg_pending) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_SET_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL_SET(cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctlm_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_INTCTLM_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_READL(addr, ret);
    }
}

static inline void trace_slavio_intctlm_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL(addr, val);
    }
}

static inline void trace_slavio_intctlm_mem_writel_enable(uint32_t val, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE(val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_disable(uint32_t val, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE(val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_target(uint32_t cpu) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_TARGET_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_TARGET(cpu);
    }
}

static inline void trace_slavio_check_interrupts(uint32_t pending, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_CHECK_INTERRUPTS_ENABLED()) {
        QEMU_SLAVIO_CHECK_INTERRUPTS(pending, intregm_disabled);
    }
}

static inline void trace_slavio_set_irq(uint32_t target_cpu, int irq, uint32_t pil, int level) {
    if (QEMU_SLAVIO_SET_IRQ_ENABLED()) {
        QEMU_SLAVIO_SET_IRQ(target_cpu, irq, pil, level);
    }
}

static inline void trace_slavio_set_timer_irq_cpu(int cpu, int level) {
    if (QEMU_SLAVIO_SET_TIMER_IRQ_CPU_ENABLED()) {
        QEMU_SLAVIO_SET_TIMER_IRQ_CPU(cpu, level);
    }
}

static inline void trace_slavio_misc_update_irq_raise(void) {
    if (QEMU_SLAVIO_MISC_UPDATE_IRQ_RAISE_ENABLED()) {
        QEMU_SLAVIO_MISC_UPDATE_IRQ_RAISE();
    }
}

static inline void trace_slavio_misc_update_irq_lower(void) {
    if (QEMU_SLAVIO_MISC_UPDATE_IRQ_LOWER_ENABLED()) {
        QEMU_SLAVIO_MISC_UPDATE_IRQ_LOWER();
    }
}

static inline void trace_slavio_set_power_fail(int power_failing, uint8_t config) {
    if (QEMU_SLAVIO_SET_POWER_FAIL_ENABLED()) {
        QEMU_SLAVIO_SET_POWER_FAIL(power_failing, config);
    }
}

static inline void trace_slavio_cfg_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_CFG_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_CFG_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_cfg_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_CFG_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_CFG_MEM_READB(ret);
    }
}

static inline void trace_slavio_diag_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_DIAG_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_DIAG_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_diag_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_DIAG_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_DIAG_MEM_READB(ret);
    }
}

static inline void trace_slavio_mdm_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_MDM_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_MDM_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_mdm_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_MDM_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_MDM_MEM_READB(ret);
    }
}

static inline void trace_slavio_aux1_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_AUX1_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_AUX1_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_aux1_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_AUX1_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_AUX1_MEM_READB(ret);
    }
}

static inline void trace_slavio_aux2_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_AUX2_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_AUX2_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_aux2_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_AUX2_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_AUX2_MEM_READB(ret);
    }
}

static inline void trace_apc_mem_writeb(uint32_t val) {
    if (QEMU_APC_MEM_WRITEB_ENABLED()) {
        QEMU_APC_MEM_WRITEB(val);
    }
}

static inline void trace_apc_mem_readb(uint32_t ret) {
    if (QEMU_APC_MEM_READB_ENABLED()) {
        QEMU_APC_MEM_READB(ret);
    }
}

static inline void trace_slavio_sysctrl_mem_writel(uint32_t val) {
    if (QEMU_SLAVIO_SYSCTRL_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_SYSCTRL_MEM_WRITEL(val);
    }
}

static inline void trace_slavio_sysctrl_mem_readl(uint32_t ret) {
    if (QEMU_SLAVIO_SYSCTRL_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_SYSCTRL_MEM_READL(ret);
    }
}

static inline void trace_slavio_led_mem_writew(uint32_t val) {
    if (QEMU_SLAVIO_LED_MEM_WRITEW_ENABLED()) {
        QEMU_SLAVIO_LED_MEM_WRITEW(val);
    }
}

static inline void trace_slavio_led_mem_readw(uint32_t ret) {
    if (QEMU_SLAVIO_LED_MEM_READW_ENABLED()) {
        QEMU_SLAVIO_LED_MEM_READW(ret);
    }
}

static inline void trace_slavio_timer_get_out(uint64_t limit, uint32_t counthigh, uint32_t count) {
    if (QEMU_SLAVIO_TIMER_GET_OUT_ENABLED()) {
        QEMU_SLAVIO_TIMER_GET_OUT(limit, counthigh, count);
    }
}

static inline void trace_slavio_timer_irq(uint32_t counthigh, uint32_t count) {
    if (QEMU_SLAVIO_TIMER_IRQ_ENABLED()) {
        QEMU_SLAVIO_TIMER_IRQ(counthigh, count);
    }
}

static inline void trace_slavio_timer_mem_readl_invalid(uint64_t addr) {
    if (QEMU_SLAVIO_TIMER_MEM_READL_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_READL_INVALID(addr);
    }
}

static inline void trace_slavio_timer_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_TIMER_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_READL(addr, ret);
    }
}

static inline void trace_slavio_timer_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL(addr, val);
    }
}

static inline void trace_slavio_timer_mem_writel_limit(unsigned int timer_index, uint64_t count) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_LIMIT_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_LIMIT(timer_index, count);
    }
}

static inline void trace_slavio_timer_mem_writel_counter_invalid(void) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID();
    }
}

static inline void trace_slavio_timer_mem_writel_status_start(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_START_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_START(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_status_stop(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_user(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_USER_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_USER(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_counter(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_invalid(void) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID();
    }
}

static inline void trace_slavio_timer_mem_writel_invalid(uint64_t addr) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_INVALID(addr);
    }
}

static inline void trace_ledma_memory_read(uint64_t addr) {
    if (QEMU_LEDMA_MEMORY_READ_ENABLED()) {
        QEMU_LEDMA_MEMORY_READ(addr);
    }
}

static inline void trace_ledma_memory_write(uint64_t addr) {
    if (QEMU_LEDMA_MEMORY_WRITE_ENABLED()) {
        QEMU_LEDMA_MEMORY_WRITE(addr);
    }
}

static inline void trace_sparc32_dma_set_irq_raise(void) {
    if (QEMU_SPARC32_DMA_SET_IRQ_RAISE_ENABLED()) {
        QEMU_SPARC32_DMA_SET_IRQ_RAISE();
    }
}

static inline void trace_sparc32_dma_set_irq_lower(void) {
    if (QEMU_SPARC32_DMA_SET_IRQ_LOWER_ENABLED()) {
        QEMU_SPARC32_DMA_SET_IRQ_LOWER();
    }
}

static inline void trace_espdma_memory_read(uint32_t addr) {
    if (QEMU_ESPDMA_MEMORY_READ_ENABLED()) {
        QEMU_ESPDMA_MEMORY_READ(addr);
    }
}

static inline void trace_espdma_memory_write(uint32_t addr) {
    if (QEMU_ESPDMA_MEMORY_WRITE_ENABLED()) {
        QEMU_ESPDMA_MEMORY_WRITE(addr);
    }
}

static inline void trace_sparc32_dma_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SPARC32_DMA_MEM_READL_ENABLED()) {
        QEMU_SPARC32_DMA_MEM_READL(addr, ret);
    }
}

static inline void trace_sparc32_dma_mem_writel(uint64_t addr, uint32_t old, uint32_t val) {
    if (QEMU_SPARC32_DMA_MEM_WRITEL_ENABLED()) {
        QEMU_SPARC32_DMA_MEM_WRITEL(addr, old, val);
    }
}

static inline void trace_sparc32_dma_enable_raise(void) {
    if (QEMU_SPARC32_DMA_ENABLE_RAISE_ENABLED()) {
        QEMU_SPARC32_DMA_ENABLE_RAISE();
    }
}

static inline void trace_sparc32_dma_enable_lower(void) {
    if (QEMU_SPARC32_DMA_ENABLE_LOWER_ENABLED()) {
        QEMU_SPARC32_DMA_ENABLE_LOWER();
    }
}

static inline void trace_sun4m_cpu_interrupt(unsigned int level) {
    if (QEMU_SUN4M_CPU_INTERRUPT_ENABLED()) {
        QEMU_SUN4M_CPU_INTERRUPT(level);
    }
}

static inline void trace_sun4m_cpu_reset_interrupt(unsigned int level) {
    if (QEMU_SUN4M_CPU_RESET_INTERRUPT_ENABLED()) {
        QEMU_SUN4M_CPU_RESET_INTERRUPT(level);
    }
}

static inline void trace_sun4m_cpu_set_irq_raise(int level) {
    if (QEMU_SUN4M_CPU_SET_IRQ_RAISE_ENABLED()) {
        QEMU_SUN4M_CPU_SET_IRQ_RAISE(level);
    }
}

static inline void trace_sun4m_cpu_set_irq_lower(int level) {
    if (QEMU_SUN4M_CPU_SET_IRQ_LOWER_ENABLED()) {
        QEMU_SUN4M_CPU_SET_IRQ_LOWER(level);
    }
}

static inline void trace_sun4m_iommu_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SUN4M_IOMMU_MEM_READL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_READL(addr, ret);
    }
}

static inline void trace_sun4m_iommu_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL(addr, val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_ctrl(uint64_t iostart) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_CTRL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_CTRL(iostart);
    }
}

static inline void trace_sun4m_iommu_mem_writel_tlbflush(uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH(val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_pgflush(uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH(val);
    }
}

static inline void trace_sun4m_iommu_page_get_flags(uint64_t pa, uint64_t iopte, uint32_t ret) {
    if (QEMU_SUN4M_IOMMU_PAGE_GET_FLAGS_ENABLED()) {
        QEMU_SUN4M_IOMMU_PAGE_GET_FLAGS(pa, iopte, ret);
    }
}

static inline void trace_sun4m_iommu_translate_pa(uint64_t addr, uint64_t pa, uint32_t iopte) {
    if (QEMU_SUN4M_IOMMU_TRANSLATE_PA_ENABLED()) {
        QEMU_SUN4M_IOMMU_TRANSLATE_PA(addr, pa, iopte);
    }
}

static inline void trace_sun4m_iommu_bad_addr(uint64_t addr) {
    if (QEMU_SUN4M_IOMMU_BAD_ADDR_ENABLED()) {
        QEMU_SUN4M_IOMMU_BAD_ADDR(addr);
    }
}

static inline void trace_usb_port_claim(int bus, const char *port) {
    if (QEMU_USB_PORT_CLAIM_ENABLED()) {
        QEMU_USB_PORT_CLAIM(bus, port);
    }
}

static inline void trace_usb_port_attach(int bus, const char *port) {
    if (QEMU_USB_PORT_ATTACH_ENABLED()) {
        QEMU_USB_PORT_ATTACH(bus, port);
    }
}

static inline void trace_usb_port_detach(int bus, const char *port) {
    if (QEMU_USB_PORT_DETACH_ENABLED()) {
        QEMU_USB_PORT_DETACH(bus, port);
    }
}

static inline void trace_usb_port_release(int bus, const char *port) {
    if (QEMU_USB_PORT_RELEASE_ENABLED()) {
        QEMU_USB_PORT_RELEASE(bus, port);
    }
}

static inline void trace_usb_ehci_reset(void) {
    if (QEMU_USB_EHCI_RESET_ENABLED()) {
        QEMU_USB_EHCI_RESET();
    }
}

static inline void trace_usb_ehci_mmio_readl(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_READL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_READL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_writel(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_WRITEL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_WRITEL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_change(uint32_t addr, const char *str, uint32_t new, uint32_t old) {
    if (QEMU_USB_EHCI_MMIO_CHANGE_ENABLED()) {
        QEMU_USB_EHCI_MMIO_CHANGE(addr, str, new, old);
    }
}

static inline void trace_usb_ehci_usbsts(const char *sts, int state) {
    if (QEMU_USB_EHCI_USBSTS_ENABLED()) {
        QEMU_USB_EHCI_USBSTS(sts, state);
    }
}

static inline void trace_usb_ehci_state(const char *schedule, const char *state) {
    if (QEMU_USB_EHCI_STATE_ENABLED()) {
        QEMU_USB_EHCI_STATE(schedule, state);
    }
}

static inline void trace_usb_ehci_qh_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t c_qtd, uint32_t n_qtd, uint32_t a_qtd) {
    if (QEMU_USB_EHCI_QH_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QH_PTRS(q, addr, nxt, c_qtd, n_qtd, a_qtd);
    }
}

static inline void trace_usb_ehci_qh_fields(uint32_t addr, int rl, int mplen, int eps, int ep, int devaddr) {
    if (QEMU_USB_EHCI_QH_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QH_FIELDS(addr, rl, mplen, eps, ep, devaddr);
    }
}

static inline void trace_usb_ehci_qh_bits(uint32_t addr, int c, int h, int dtc, int i) {
    if (QEMU_USB_EHCI_QH_BITS_ENABLED()) {
        QEMU_USB_EHCI_QH_BITS(addr, c, h, dtc, i);
    }
}

static inline void trace_usb_ehci_qtd_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t altnext) {
    if (QEMU_USB_EHCI_QTD_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QTD_PTRS(q, addr, nxt, altnext);
    }
}

static inline void trace_usb_ehci_qtd_fields(uint32_t addr, int tbytes, int cpage, int cerr, int pid) {
    if (QEMU_USB_EHCI_QTD_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QTD_FIELDS(addr, tbytes, cpage, cerr, pid);
    }
}

static inline void trace_usb_ehci_qtd_bits(uint32_t addr, int ioc, int active, int halt, int babble, int xacterr) {
    if (QEMU_USB_EHCI_QTD_BITS_ENABLED()) {
        QEMU_USB_EHCI_QTD_BITS(addr, ioc, active, halt, babble, xacterr);
    }
}

static inline void trace_usb_ehci_itd(uint32_t addr, uint32_t nxt, uint32_t mplen, uint32_t mult, uint32_t ep, uint32_t devaddr) {
    if (QEMU_USB_EHCI_ITD_ENABLED()) {
        QEMU_USB_EHCI_ITD(addr, nxt, mplen, mult, ep, devaddr);
    }
}

static inline void trace_usb_ehci_sitd(uint32_t addr, uint32_t nxt, uint32_t active) {
    if (QEMU_USB_EHCI_SITD_ENABLED()) {
        QEMU_USB_EHCI_SITD(addr, nxt, active);
    }
}

static inline void trace_usb_ehci_port_attach(uint32_t port, const char *device) {
    if (QEMU_USB_EHCI_PORT_ATTACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_ATTACH(port, device);
    }
}

static inline void trace_usb_ehci_port_detach(uint32_t port) {
    if (QEMU_USB_EHCI_PORT_DETACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_DETACH(port);
    }
}

static inline void trace_usb_ehci_port_reset(uint32_t port, int enable) {
    if (QEMU_USB_EHCI_PORT_RESET_ENABLED()) {
        QEMU_USB_EHCI_PORT_RESET(port, enable);
    }
}

static inline void trace_usb_ehci_data(int rw, uint32_t cpage, uint32_t offset, uint32_t addr, uint32_t len, uint32_t bufpos) {
    if (QEMU_USB_EHCI_DATA_ENABLED()) {
        QEMU_USB_EHCI_DATA(rw, cpage, offset, addr, len, bufpos);
    }
}

static inline void trace_usb_ehci_queue_action(void *q, const char *action) {
    if (QEMU_USB_EHCI_QUEUE_ACTION_ENABLED()) {
        QEMU_USB_EHCI_QUEUE_ACTION(q, action);
    }
}

static inline void trace_usb_desc_device(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_ENABLED()) {
        QEMU_USB_DESC_DEVICE(addr, len, ret);
    }
}

static inline void trace_usb_desc_device_qualifier(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_QUALIFIER_ENABLED()) {
        QEMU_USB_DESC_DEVICE_QUALIFIER(addr, len, ret);
    }
}

static inline void trace_usb_desc_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_CONFIG_ENABLED()) {
        QEMU_USB_DESC_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_other_speed_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_OTHER_SPEED_CONFIG_ENABLED()) {
        QEMU_USB_DESC_OTHER_SPEED_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_string(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_STRING_ENABLED()) {
        QEMU_USB_DESC_STRING(addr, index, len, ret);
    }
}

static inline void trace_usb_set_addr(int addr) {
    if (QEMU_USB_SET_ADDR_ENABLED()) {
        QEMU_USB_SET_ADDR(addr);
    }
}

static inline void trace_usb_set_config(int addr, int config, int ret) {
    if (QEMU_USB_SET_CONFIG_ENABLED()) {
        QEMU_USB_SET_CONFIG(addr, config, ret);
    }
}

static inline void trace_usb_clear_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_CLEAR_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_CLEAR_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_set_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_SET_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_SET_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_host_open_started(int bus, int addr) {
    if (QEMU_USB_HOST_OPEN_STARTED_ENABLED()) {
        QEMU_USB_HOST_OPEN_STARTED(bus, addr);
    }
}

static inline void trace_usb_host_open_success(int bus, int addr) {
    if (QEMU_USB_HOST_OPEN_SUCCESS_ENABLED()) {
        QEMU_USB_HOST_OPEN_SUCCESS(bus, addr);
    }
}

static inline void trace_usb_host_open_failure(int bus, int addr) {
    if (QEMU_USB_HOST_OPEN_FAILURE_ENABLED()) {
        QEMU_USB_HOST_OPEN_FAILURE(bus, addr);
    }
}

static inline void trace_usb_host_disconnect(int bus, int addr) {
    if (QEMU_USB_HOST_DISCONNECT_ENABLED()) {
        QEMU_USB_HOST_DISCONNECT(bus, addr);
    }
}

static inline void trace_usb_host_close(int bus, int addr) {
    if (QEMU_USB_HOST_CLOSE_ENABLED()) {
        QEMU_USB_HOST_CLOSE(bus, addr);
    }
}

static inline void trace_usb_host_set_address(int bus, int addr, int config) {
    if (QEMU_USB_HOST_SET_ADDRESS_ENABLED()) {
        QEMU_USB_HOST_SET_ADDRESS(bus, addr, config);
    }
}

static inline void trace_usb_host_set_config(int bus, int addr, int config) {
    if (QEMU_USB_HOST_SET_CONFIG_ENABLED()) {
        QEMU_USB_HOST_SET_CONFIG(bus, addr, config);
    }
}

static inline void trace_usb_host_set_interface(int bus, int addr, int interface, int alt) {
    if (QEMU_USB_HOST_SET_INTERFACE_ENABLED()) {
        QEMU_USB_HOST_SET_INTERFACE(bus, addr, interface, alt);
    }
}

static inline void trace_usb_host_claim_interfaces(int bus, int addr, int config, int nif) {
    if (QEMU_USB_HOST_CLAIM_INTERFACES_ENABLED()) {
        QEMU_USB_HOST_CLAIM_INTERFACES(bus, addr, config, nif);
    }
}

static inline void trace_usb_host_release_interfaces(int bus, int addr) {
    if (QEMU_USB_HOST_RELEASE_INTERFACES_ENABLED()) {
        QEMU_USB_HOST_RELEASE_INTERFACES(bus, addr);
    }
}

static inline void trace_usb_host_req_control(int bus, int addr, int req, int value, int index) {
    if (QEMU_USB_HOST_REQ_CONTROL_ENABLED()) {
        QEMU_USB_HOST_REQ_CONTROL(bus, addr, req, value, index);
    }
}

static inline void trace_usb_host_req_data(int bus, int addr, int in, int ep, int size) {
    if (QEMU_USB_HOST_REQ_DATA_ENABLED()) {
        QEMU_USB_HOST_REQ_DATA(bus, addr, in, ep, size);
    }
}

static inline void trace_usb_host_req_complete(int bus, int addr, int status) {
    if (QEMU_USB_HOST_REQ_COMPLETE_ENABLED()) {
        QEMU_USB_HOST_REQ_COMPLETE(bus, addr, status);
    }
}

static inline void trace_usb_host_urb_submit(int bus, int addr, void *aurb, int length, int more) {
    if (QEMU_USB_HOST_URB_SUBMIT_ENABLED()) {
        QEMU_USB_HOST_URB_SUBMIT(bus, addr, aurb, length, more);
    }
}

static inline void trace_usb_host_urb_complete(int bus, int addr, void *aurb, int status, int length, int more) {
    if (QEMU_USB_HOST_URB_COMPLETE_ENABLED()) {
        QEMU_USB_HOST_URB_COMPLETE(bus, addr, aurb, status, length, more);
    }
}

static inline void trace_usb_host_ep_set_halt(int bus, int addr, int ep) {
    if (QEMU_USB_HOST_EP_SET_HALT_ENABLED()) {
        QEMU_USB_HOST_EP_SET_HALT(bus, addr, ep);
    }
}

static inline void trace_usb_host_ep_clear_halt(int bus, int addr, int ep) {
    if (QEMU_USB_HOST_EP_CLEAR_HALT_ENABLED()) {
        QEMU_USB_HOST_EP_CLEAR_HALT(bus, addr, ep);
    }
}

static inline void trace_usb_host_ep_start_iso(int bus, int addr, int ep) {
    if (QEMU_USB_HOST_EP_START_ISO_ENABLED()) {
        QEMU_USB_HOST_EP_START_ISO(bus, addr, ep);
    }
}

static inline void trace_usb_host_ep_stop_iso(int bus, int addr, int ep) {
    if (QEMU_USB_HOST_EP_STOP_ISO_ENABLED()) {
        QEMU_USB_HOST_EP_STOP_ISO(bus, addr, ep);
    }
}

static inline void trace_usb_host_reset(int bus, int addr) {
    if (QEMU_USB_HOST_RESET_ENABLED()) {
        QEMU_USB_HOST_RESET(bus, addr);
    }
}

static inline void trace_usb_host_auto_scan_enabled(void) {
    if (QEMU_USB_HOST_AUTO_SCAN_ENABLED_ENABLED()) {
        QEMU_USB_HOST_AUTO_SCAN_ENABLED();
    }
}

static inline void trace_usb_host_auto_scan_disabled(void) {
    if (QEMU_USB_HOST_AUTO_SCAN_DISABLED_ENABLED()) {
        QEMU_USB_HOST_AUTO_SCAN_DISABLED();
    }
}

static inline void trace_usb_host_claim_port(int bus, int hub, int port) {
    if (QEMU_USB_HOST_CLAIM_PORT_ENABLED()) {
        QEMU_USB_HOST_CLAIM_PORT(bus, hub, port);
    }
}

static inline void trace_scsi_req_alloc(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_ALLOC_ENABLED()) {
        QEMU_SCSI_REQ_ALLOC(target, lun, tag);
    }
}

static inline void trace_scsi_req_data(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_ENABLED()) {
        QEMU_SCSI_REQ_DATA(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_data_canceled(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_CANCELED_ENABLED()) {
        QEMU_SCSI_REQ_DATA_CANCELED(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_dequeue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_DEQUEUE_ENABLED()) {
        QEMU_SCSI_REQ_DEQUEUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_continue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_CONTINUE_ENABLED()) {
        QEMU_SCSI_REQ_CONTINUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_parsed(int target, int lun, int tag, int cmd, int mode, int xfer) {
    if (QEMU_SCSI_REQ_PARSED_ENABLED()) {
        QEMU_SCSI_REQ_PARSED(target, lun, tag, cmd, mode, xfer);
    }
}

static inline void trace_scsi_req_parsed_lba(int target, int lun, int tag, int cmd, uint64_t lba) {
    if (QEMU_SCSI_REQ_PARSED_LBA_ENABLED()) {
        QEMU_SCSI_REQ_PARSED_LBA(target, lun, tag, cmd, lba);
    }
}

static inline void trace_scsi_req_parse_bad(int target, int lun, int tag, int cmd) {
    if (QEMU_SCSI_REQ_PARSE_BAD_ENABLED()) {
        QEMU_SCSI_REQ_PARSE_BAD(target, lun, tag, cmd);
    }
}

static inline void trace_scsi_req_build_sense(int target, int lun, int tag, int key, int asc, int ascq) {
    if (QEMU_SCSI_REQ_BUILD_SENSE_ENABLED()) {
        QEMU_SCSI_REQ_BUILD_SENSE(target, lun, tag, key, asc, ascq);
    }
}

static inline void trace_scsi_report_luns(int target, int lun, int tag) {
    if (QEMU_SCSI_REPORT_LUNS_ENABLED()) {
        QEMU_SCSI_REPORT_LUNS(target, lun, tag);
    }
}

static inline void trace_scsi_inquiry(int target, int lun, int tag, int cdb1, int cdb2) {
    if (QEMU_SCSI_INQUIRY_ENABLED()) {
        QEMU_SCSI_INQUIRY(target, lun, tag, cdb1, cdb2);
    }
}

static inline void trace_scsi_test_unit_ready(int target, int lun, int tag) {
    if (QEMU_SCSI_TEST_UNIT_READY_ENABLED()) {
        QEMU_SCSI_TEST_UNIT_READY(target, lun, tag);
    }
}

static inline void trace_scsi_request_sense(int target, int lun, int tag) {
    if (QEMU_SCSI_REQUEST_SENSE_ENABLED()) {
        QEMU_SCSI_REQUEST_SENSE(target, lun, tag);
    }
}

static inline void trace_vm_state_notify(int running, int reason) {
    if (QEMU_VM_STATE_NOTIFY_ENABLED()) {
        QEMU_VM_STATE_NOTIFY(running, reason);
    }
}

static inline void trace_qed_alloc_l2_cache_entry(void *l2_cache, void *entry) {
    if (QEMU_QED_ALLOC_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_ALLOC_L2_CACHE_ENTRY(l2_cache, entry);
    }
}

static inline void trace_qed_unref_l2_cache_entry(void *entry, int ref) {
    if (QEMU_QED_UNREF_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_UNREF_L2_CACHE_ENTRY(entry, ref);
    }
}

static inline void trace_qed_find_l2_cache_entry(void *l2_cache, void *entry, uint64_t offset, int ref) {
    if (QEMU_QED_FIND_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_FIND_L2_CACHE_ENTRY(l2_cache, entry, offset, ref);
    }
}

static inline void trace_qed_read_table(void *s, uint64_t offset, void *table) {
    if (QEMU_QED_READ_TABLE_ENABLED()) {
        QEMU_QED_READ_TABLE(s, offset, table);
    }
}

static inline void trace_qed_read_table_cb(void *s, void *table, int ret) {
    if (QEMU_QED_READ_TABLE_CB_ENABLED()) {
        QEMU_QED_READ_TABLE_CB(s, table, ret);
    }
}

static inline void trace_qed_write_table(void *s, uint64_t offset, void *table, unsigned int index, unsigned int n) {
    if (QEMU_QED_WRITE_TABLE_ENABLED()) {
        QEMU_QED_WRITE_TABLE(s, offset, table, index, n);
    }
}

static inline void trace_qed_write_table_cb(void *s, void *table, int flush, int ret) {
    if (QEMU_QED_WRITE_TABLE_CB_ENABLED()) {
        QEMU_QED_WRITE_TABLE_CB(s, table, flush, ret);
    }
}

static inline void trace_qed_need_check_timer_cb(void *s) {
    if (QEMU_QED_NEED_CHECK_TIMER_CB_ENABLED()) {
        QEMU_QED_NEED_CHECK_TIMER_CB(s);
    }
}

static inline void trace_qed_start_need_check_timer(void *s) {
    if (QEMU_QED_START_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_START_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_cancel_need_check_timer(void *s) {
    if (QEMU_QED_CANCEL_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_CANCEL_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_aio_complete(void *s, void *acb, int ret) {
    if (QEMU_QED_AIO_COMPLETE_ENABLED()) {
        QEMU_QED_AIO_COMPLETE(s, acb, ret);
    }
}

static inline void trace_qed_aio_setup(void *s, void *acb, int64_t sector_num, int nb_sectors, void *opaque, int is_write) {
    if (QEMU_QED_AIO_SETUP_ENABLED()) {
        QEMU_QED_AIO_SETUP(s, acb, sector_num, nb_sectors, opaque, is_write);
    }
}

static inline void trace_qed_aio_next_io(void *s, void *acb, int ret, uint64_t cur_pos) {
    if (QEMU_QED_AIO_NEXT_IO_ENABLED()) {
        QEMU_QED_AIO_NEXT_IO(s, acb, ret, cur_pos);
    }
}

static inline void trace_qed_aio_read_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_READ_DATA_ENABLED()) {
        QEMU_QED_AIO_READ_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_DATA_ENABLED()) {
        QEMU_QED_AIO_WRITE_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_prefill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_PREFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_PREFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_postfill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_POSTFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_POSTFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_main(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_MAIN_ENABLED()) {
        QEMU_QED_AIO_WRITE_MAIN(s, acb, ret, offset, len);
    }
}

static inline void trace_g364fb_read(uint64_t addr, uint32_t val) {
    if (QEMU_G364FB_READ_ENABLED()) {
        QEMU_G364FB_READ(addr, val);
    }
}

static inline void trace_g364fb_write(uint64_t addr, uint32_t new) {
    if (QEMU_G364FB_WRITE_ENABLED()) {
        QEMU_G364FB_WRITE(addr, new);
    }
}

static inline void trace_grlib_gptimer_enable(int id, uint32_t count) {
    if (QEMU_GRLIB_GPTIMER_ENABLE_ENABLED()) {
        QEMU_GRLIB_GPTIMER_ENABLE(id, count);
    }
}

static inline void trace_grlib_gptimer_disabled(int id, uint32_t config) {
    if (QEMU_GRLIB_GPTIMER_DISABLED_ENABLED()) {
        QEMU_GRLIB_GPTIMER_DISABLED(id, config);
    }
}

static inline void trace_grlib_gptimer_restart(int id, uint32_t reload) {
    if (QEMU_GRLIB_GPTIMER_RESTART_ENABLED()) {
        QEMU_GRLIB_GPTIMER_RESTART(id, reload);
    }
}

static inline void trace_grlib_gptimer_set_scaler(uint32_t scaler, uint32_t freq) {
    if (QEMU_GRLIB_GPTIMER_SET_SCALER_ENABLED()) {
        QEMU_GRLIB_GPTIMER_SET_SCALER(scaler, freq);
    }
}

static inline void trace_grlib_gptimer_hit(int id) {
    if (QEMU_GRLIB_GPTIMER_HIT_ENABLED()) {
        QEMU_GRLIB_GPTIMER_HIT(id);
    }
}

static inline void trace_grlib_gptimer_readl(int id, uint64_t addr, uint32_t val) {
    if (QEMU_GRLIB_GPTIMER_READL_ENABLED()) {
        QEMU_GRLIB_GPTIMER_READL(id, addr, val);
    }
}

static inline void trace_grlib_gptimer_writel(int id, uint64_t addr, uint32_t val) {
    if (QEMU_GRLIB_GPTIMER_WRITEL_ENABLED()) {
        QEMU_GRLIB_GPTIMER_WRITEL(id, addr, val);
    }
}

static inline void trace_grlib_irqmp_check_irqs(uint32_t pend, uint32_t force, uint32_t mask, uint32_t lvl1, uint32_t lvl2) {
    if (QEMU_GRLIB_IRQMP_CHECK_IRQS_ENABLED()) {
        QEMU_GRLIB_IRQMP_CHECK_IRQS(pend, force, mask, lvl1, lvl2);
    }
}

static inline void trace_grlib_irqmp_ack(int intno) {
    if (QEMU_GRLIB_IRQMP_ACK_ENABLED()) {
        QEMU_GRLIB_IRQMP_ACK(intno);
    }
}

static inline void trace_grlib_irqmp_set_irq(int irq) {
    if (QEMU_GRLIB_IRQMP_SET_IRQ_ENABLED()) {
        QEMU_GRLIB_IRQMP_SET_IRQ(irq);
    }
}

static inline void trace_grlib_irqmp_readl_unknown(uint64_t addr) {
    if (QEMU_GRLIB_IRQMP_READL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_IRQMP_READL_UNKNOWN(addr);
    }
}

static inline void trace_grlib_irqmp_writel_unknown(uint64_t addr, uint32_t value) {
    if (QEMU_GRLIB_IRQMP_WRITEL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_IRQMP_WRITEL_UNKNOWN(addr, value);
    }
}

static inline void trace_grlib_apbuart_event(int event) {
    if (QEMU_GRLIB_APBUART_EVENT_ENABLED()) {
        QEMU_GRLIB_APBUART_EVENT(event);
    }
}

static inline void trace_grlib_apbuart_writel_unknown(uint64_t addr, uint32_t value) {
    if (QEMU_GRLIB_APBUART_WRITEL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_APBUART_WRITEL_UNKNOWN(addr, value);
    }
}

static inline void trace_leon3_set_irq(int intno) {
    if (QEMU_LEON3_SET_IRQ_ENABLED()) {
        QEMU_LEON3_SET_IRQ(intno);
    }
}

static inline void trace_leon3_reset_irq(int intno) {
    if (QEMU_LEON3_RESET_IRQ_ENABLED()) {
        QEMU_LEON3_RESET_IRQ(intno);
    }
}

static inline void trace_spice_vmc_write(ssize_t out, int len) {
    if (QEMU_SPICE_VMC_WRITE_ENABLED()) {
        QEMU_SPICE_VMC_WRITE(out, len);
    }
}

static inline void trace_spice_vmc_read(int bytes, int len) {
    if (QEMU_SPICE_VMC_READ_ENABLED()) {
        QEMU_SPICE_VMC_READ(bytes, len);
    }
}

static inline void trace_spice_vmc_register_interface(void *scd) {
    if (QEMU_SPICE_VMC_REGISTER_INTERFACE_ENABLED()) {
        QEMU_SPICE_VMC_REGISTER_INTERFACE(scd);
    }
}

static inline void trace_spice_vmc_unregister_interface(void *scd) {
    if (QEMU_SPICE_VMC_UNREGISTER_INTERFACE_ENABLED()) {
        QEMU_SPICE_VMC_UNREGISTER_INTERFACE(scd);
    }
}

static inline void trace_lm32_pic_raise_irq(void) {
    if (QEMU_LM32_PIC_RAISE_IRQ_ENABLED()) {
        QEMU_LM32_PIC_RAISE_IRQ();
    }
}

static inline void trace_lm32_pic_lower_irq(void) {
    if (QEMU_LM32_PIC_LOWER_IRQ_ENABLED()) {
        QEMU_LM32_PIC_LOWER_IRQ();
    }
}

static inline void trace_lm32_pic_interrupt(int irq, int level) {
    if (QEMU_LM32_PIC_INTERRUPT_ENABLED()) {
        QEMU_LM32_PIC_INTERRUPT(irq, level);
    }
}

static inline void trace_lm32_pic_set_im(uint32_t im) {
    if (QEMU_LM32_PIC_SET_IM_ENABLED()) {
        QEMU_LM32_PIC_SET_IM(im);
    }
}

static inline void trace_lm32_pic_set_ip(uint32_t ip) {
    if (QEMU_LM32_PIC_SET_IP_ENABLED()) {
        QEMU_LM32_PIC_SET_IP(ip);
    }
}

static inline void trace_lm32_pic_get_im(uint32_t im) {
    if (QEMU_LM32_PIC_GET_IM_ENABLED()) {
        QEMU_LM32_PIC_GET_IM(im);
    }
}

static inline void trace_lm32_pic_get_ip(uint32_t ip) {
    if (QEMU_LM32_PIC_GET_IP_ENABLED()) {
        QEMU_LM32_PIC_GET_IP(ip);
    }
}

static inline void trace_lm32_juart_get_jtx(uint32_t value) {
    if (QEMU_LM32_JUART_GET_JTX_ENABLED()) {
        QEMU_LM32_JUART_GET_JTX(value);
    }
}

static inline void trace_lm32_juart_set_jtx(uint32_t value) {
    if (QEMU_LM32_JUART_SET_JTX_ENABLED()) {
        QEMU_LM32_JUART_SET_JTX(value);
    }
}

static inline void trace_lm32_juart_get_jrx(uint32_t value) {
    if (QEMU_LM32_JUART_GET_JRX_ENABLED()) {
        QEMU_LM32_JUART_GET_JRX(value);
    }
}

static inline void trace_lm32_juart_set_jrx(uint32_t value) {
    if (QEMU_LM32_JUART_SET_JRX_ENABLED()) {
        QEMU_LM32_JUART_SET_JRX(value);
    }
}

static inline void trace_lm32_timer_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_TIMER_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_TIMER_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_lm32_timer_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_TIMER_MEMORY_READ_ENABLED()) {
        QEMU_LM32_TIMER_MEMORY_READ(addr, value);
    }
}

static inline void trace_lm32_timer_hit(void) {
    if (QEMU_LM32_TIMER_HIT_ENABLED()) {
        QEMU_LM32_TIMER_HIT();
    }
}

static inline void trace_lm32_timer_irq_state(int level) {
    if (QEMU_LM32_TIMER_IRQ_STATE_ENABLED()) {
        QEMU_LM32_TIMER_IRQ_STATE(level);
    }
}

static inline void trace_lm32_uart_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_UART_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_UART_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_lm32_uart_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_UART_MEMORY_READ_ENABLED()) {
        QEMU_LM32_UART_MEMORY_READ(addr, value);
    }
}

static inline void trace_lm32_uart_irq_state(int level) {
    if (QEMU_LM32_UART_IRQ_STATE_ENABLED()) {
        QEMU_LM32_UART_IRQ_STATE(level);
    }
}

static inline void trace_lm32_sys_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_SYS_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_SYS_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_ac97_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_AC97_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_AC97_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_ac97_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_AC97_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_AC97_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crrequest(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crreply(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREPLY_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREPLY();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmaw(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAW_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAW();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmar(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAR_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAR();
    }
}

static inline void trace_milkymist_ac97_in_cb(int avail, uint32_t remaining) {
    if (QEMU_MILKYMIST_AC97_IN_CB_ENABLED()) {
        QEMU_MILKYMIST_AC97_IN_CB(avail, remaining);
    }
}

static inline void trace_milkymist_ac97_in_cb_transferred(int transferred) {
    if (QEMU_MILKYMIST_AC97_IN_CB_TRANSFERRED_ENABLED()) {
        QEMU_MILKYMIST_AC97_IN_CB_TRANSFERRED(transferred);
    }
}

static inline void trace_milkymist_ac97_out_cb(int free, uint32_t remaining) {
    if (QEMU_MILKYMIST_AC97_OUT_CB_ENABLED()) {
        QEMU_MILKYMIST_AC97_OUT_CB(free, remaining);
    }
}

static inline void trace_milkymist_ac97_out_cb_transferred(int transferred) {
    if (QEMU_MILKYMIST_AC97_OUT_CB_TRANSFERRED_ENABLED()) {
        QEMU_MILKYMIST_AC97_OUT_CB_TRANSFERRED(transferred);
    }
}

static inline void trace_milkymist_hpdmc_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_HPDMC_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_HPDMC_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_hpdmc_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_HPDMC_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_HPDMC_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MEMCARD_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_MEMCARD_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MEMCARD_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MEMCARD_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_write(uint8_t phy_addr, uint8_t addr, uint16_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MDIO_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MDIO_WRITE(phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_read(uint8_t phy_addr, uint8_t addr, uint16_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MDIO_READ_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MDIO_READ(phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_tx_frame(uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_TX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_TX_FRAME(length);
    }
}

static inline void trace_milkymist_minimac2_rx_frame(const void *buf, uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_RX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RX_FRAME(buf, length);
    }
}

static inline void trace_milkymist_minimac2_drop_rx_frame(const void *buf) {
    if (QEMU_MILKYMIST_MINIMAC2_DROP_RX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_DROP_RX_FRAME(buf);
    }
}

static inline void trace_milkymist_minimac2_rx_transfer(const void *buf, uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_RX_TRANSFER_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RX_TRANSFER(buf, length);
    }
}

static inline void trace_milkymist_minimac2_raise_irq_rx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_RAISE_IRQ_RX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RAISE_IRQ_RX();
    }
}

static inline void trace_milkymist_minimac2_lower_irq_rx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_LOWER_IRQ_RX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_LOWER_IRQ_RX();
    }
}

static inline void trace_milkymist_minimac2_pulse_irq_tx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_PULSE_IRQ_TX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_PULSE_IRQ_TX();
    }
}

static inline void trace_milkymist_pfpu_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_PFPU_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_PFPU_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_pfpu_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_PFPU_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_PFPU_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_pfpu_vectout(uint32_t a, uint32_t b, uint32_t dma_ptr) {
    if (QEMU_MILKYMIST_PFPU_VECTOUT_ENABLED()) {
        QEMU_MILKYMIST_PFPU_VECTOUT(a, b, dma_ptr);
    }
}

static inline void trace_milkymist_pfpu_pulse_irq(void) {
    if (QEMU_MILKYMIST_PFPU_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_PFPU_PULSE_IRQ();
    }
}

static inline void trace_milkymist_softusb_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SOFTUSB_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_softusb_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SOFTUSB_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_softusb_mevt(uint8_t m) {
    if (QEMU_MILKYMIST_SOFTUSB_MEVT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEVT(m);
    }
}

static inline void trace_milkymist_softusb_kevt(uint8_t m) {
    if (QEMU_MILKYMIST_SOFTUSB_KEVT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_KEVT(m);
    }
}

static inline void trace_milkymist_softusb_mouse_event(int dx, int dy, int dz, int bs) {
    if (QEMU_MILKYMIST_SOFTUSB_MOUSE_EVENT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MOUSE_EVENT(dx, dy, dz, bs);
    }
}

static inline void trace_milkymist_softusb_pulse_irq(void) {
    if (QEMU_MILKYMIST_SOFTUSB_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_PULSE_IRQ();
    }
}

static inline void trace_milkymist_sysctl_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_sysctl_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_sysctl_icap_write(uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_ICAP_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_ICAP_WRITE(value);
    }
}

static inline void trace_milkymist_sysctl_start_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_START_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_START_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_stop_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_STOP_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_STOP_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_start_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_START_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_START_TIMER1();
    }
}

static inline void trace_milkymist_sysctl_stop_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_STOP_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_STOP_TIMER1();
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1();
    }
}

static inline void trace_milkymist_tmu2_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_TMU2_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_TMU2_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_tmu2_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_TMU2_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_TMU2_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_tmu2_start(void) {
    if (QEMU_MILKYMIST_TMU2_START_ENABLED()) {
        QEMU_MILKYMIST_TMU2_START();
    }
}

static inline void trace_milkymist_tmu2_pulse_irq(void) {
    if (QEMU_MILKYMIST_TMU2_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_TMU2_PULSE_IRQ();
    }
}

static inline void trace_milkymist_uart_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_UART_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_UART_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_uart_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_UART_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_UART_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_uart_raise_irq(void) {
    if (QEMU_MILKYMIST_UART_RAISE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_UART_RAISE_IRQ();
    }
}

static inline void trace_milkymist_uart_lower_irq(void) {
    if (QEMU_MILKYMIST_UART_LOWER_IRQ_ENABLED()) {
        QEMU_MILKYMIST_UART_LOWER_IRQ();
    }
}

static inline void trace_milkymist_vgafb_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_VGAFB_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_VGAFB_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_vgafb_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_VGAFB_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_VGAFB_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_mipsnet_send(uint32_t size) {
    if (QEMU_MIPSNET_SEND_ENABLED()) {
        QEMU_MIPSNET_SEND(size);
    }
}

static inline void trace_mipsnet_receive(uint32_t size) {
    if (QEMU_MIPSNET_RECEIVE_ENABLED()) {
        QEMU_MIPSNET_RECEIVE(size);
    }
}

static inline void trace_mipsnet_read(uint64_t addr, uint32_t val) {
    if (QEMU_MIPSNET_READ_ENABLED()) {
        QEMU_MIPSNET_READ(addr, val);
    }
}

static inline void trace_mipsnet_write(uint64_t addr, uint64_t val) {
    if (QEMU_MIPSNET_WRITE_ENABLED()) {
        QEMU_MIPSNET_WRITE(addr, val);
    }
}

static inline void trace_mipsnet_irq(uint32_t isr, uint32_t intctl) {
    if (QEMU_MIPSNET_IRQ_ENABLED()) {
        QEMU_MIPSNET_IRQ(isr, intctl);
    }
}

static inline void trace_xen_ram_alloc(unsigned long ram_addr, unsigned long size) {
    if (QEMU_XEN_RAM_ALLOC_ENABLED()) {
        QEMU_XEN_RAM_ALLOC(ram_addr, size);
    }
}

static inline void trace_xen_client_set_memory(uint64_t start_addr, unsigned long size, unsigned long phys_offset, bool log_dirty) {
    if (QEMU_XEN_CLIENT_SET_MEMORY_ENABLED()) {
        QEMU_XEN_CLIENT_SET_MEMORY(start_addr, size, phys_offset, log_dirty);
    }
}

static inline void trace_xen_map_cache(uint64_t phys_addr) {
    if (QEMU_XEN_MAP_CACHE_ENABLED()) {
        QEMU_XEN_MAP_CACHE(phys_addr);
    }
}

static inline void trace_xen_remap_bucket(uint64_t index) {
    if (QEMU_XEN_REMAP_BUCKET_ENABLED()) {
        QEMU_XEN_REMAP_BUCKET(index);
    }
}

static inline void trace_xen_map_cache_return(void* ptr) {
    if (QEMU_XEN_MAP_CACHE_RETURN_ENABLED()) {
        QEMU_XEN_MAP_CACHE_RETURN(ptr);
    }
}

static inline void trace_xen_map_block(uint64_t phys_addr, uint64_t size) {
    if (QEMU_XEN_MAP_BLOCK_ENABLED()) {
        QEMU_XEN_MAP_BLOCK(phys_addr, size);
    }
}

static inline void trace_xen_unmap_block(void* addr, unsigned long size) {
    if (QEMU_XEN_UNMAP_BLOCK_ENABLED()) {
        QEMU_XEN_UNMAP_BLOCK(addr, size);
    }
}

static inline void trace_qemu_put_ram_ptr(void* addr) {
    if (QEMU_QEMU_PUT_RAM_PTR_ENABLED()) {
        QEMU_QEMU_PUT_RAM_PTR(addr);
    }
}

static inline void trace_xen_platform_log(char *s) {
    if (QEMU_XEN_PLATFORM_LOG_ENABLED()) {
        QEMU_XEN_PLATFORM_LOG(s);
    }
}

static inline void trace_qemu_coroutine_enter(void *from, void *to, void *opaque) {
    if (QEMU_QEMU_COROUTINE_ENTER_ENABLED()) {
        QEMU_QEMU_COROUTINE_ENTER(from, to, opaque);
    }
}

static inline void trace_qemu_coroutine_yield(void *from, void *to) {
    if (QEMU_QEMU_COROUTINE_YIELD_ENABLED()) {
        QEMU_QEMU_COROUTINE_YIELD(from, to);
    }
}

static inline void trace_qemu_coroutine_terminate(void *co) {
    if (QEMU_QEMU_COROUTINE_TERMINATE_ENABLED()) {
        QEMU_QEMU_COROUTINE_TERMINATE(co);
    }
}

static inline void trace_qemu_co_queue_next_bh(void) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_BH_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT_BH();
    }
}

static inline void trace_qemu_co_queue_next(void *next) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT(next);
    }
}

static inline void trace_qemu_co_mutex_lock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_lock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_RETURN(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN(mutex, self);
    }
}

static inline void trace_escc_put_queue(char channel, int b) {
    if (QEMU_ESCC_PUT_QUEUE_ENABLED()) {
        QEMU_ESCC_PUT_QUEUE(channel, b);
    }
}

static inline void trace_escc_get_queue(char channel, int val) {
    if (QEMU_ESCC_GET_QUEUE_ENABLED()) {
        QEMU_ESCC_GET_QUEUE(channel, val);
    }
}

static inline void trace_escc_update_irq(int irq) {
    if (QEMU_ESCC_UPDATE_IRQ_ENABLED()) {
        QEMU_ESCC_UPDATE_IRQ(irq);
    }
}

static inline void trace_escc_update_parameters(char channel, int speed, int parity, int data_bits, int stop_bits) {
    if (QEMU_ESCC_UPDATE_PARAMETERS_ENABLED()) {
        QEMU_ESCC_UPDATE_PARAMETERS(channel, speed, parity, data_bits, stop_bits);
    }
}

static inline void trace_escc_mem_writeb_ctrl(char channel, uint32_t reg, uint32_t val) {
    if (QEMU_ESCC_MEM_WRITEB_CTRL_ENABLED()) {
        QEMU_ESCC_MEM_WRITEB_CTRL(channel, reg, val);
    }
}

static inline void trace_escc_mem_writeb_data(char channel, uint32_t val) {
    if (QEMU_ESCC_MEM_WRITEB_DATA_ENABLED()) {
        QEMU_ESCC_MEM_WRITEB_DATA(channel, val);
    }
}

static inline void trace_escc_mem_readb_ctrl(char channel, uint32_t reg, uint8_t val) {
    if (QEMU_ESCC_MEM_READB_CTRL_ENABLED()) {
        QEMU_ESCC_MEM_READB_CTRL(channel, reg, val);
    }
}

static inline void trace_escc_mem_readb_data(char channel, uint32_t ret) {
    if (QEMU_ESCC_MEM_READB_DATA_ENABLED()) {
        QEMU_ESCC_MEM_READB_DATA(channel, ret);
    }
}

static inline void trace_escc_serial_receive_byte(char channel, int ch) {
    if (QEMU_ESCC_SERIAL_RECEIVE_BYTE_ENABLED()) {
        QEMU_ESCC_SERIAL_RECEIVE_BYTE(channel, ch);
    }
}

static inline void trace_escc_sunkbd_event_in(int ch) {
    if (QEMU_ESCC_SUNKBD_EVENT_IN_ENABLED()) {
        QEMU_ESCC_SUNKBD_EVENT_IN(ch);
    }
}

static inline void trace_escc_sunkbd_event_out(int ch) {
    if (QEMU_ESCC_SUNKBD_EVENT_OUT_ENABLED()) {
        QEMU_ESCC_SUNKBD_EVENT_OUT(ch);
    }
}

static inline void trace_escc_kbd_command(int val) {
    if (QEMU_ESCC_KBD_COMMAND_ENABLED()) {
        QEMU_ESCC_KBD_COMMAND(val);
    }
}

static inline void trace_escc_sunmouse_event(int dx, int dy, int buttons_state) {
    if (QEMU_ESCC_SUNMOUSE_EVENT_ENABLED()) {
        QEMU_ESCC_SUNMOUSE_EVENT(dx, dy, buttons_state);
    }
}

static inline void trace_iscsi_aio_write10_cb(void *iscsi, int status, void *acb, int canceled) {
    if (QEMU_ISCSI_AIO_WRITE10_CB_ENABLED()) {
        QEMU_ISCSI_AIO_WRITE10_CB(iscsi, status, acb, canceled);
    }
}

static inline void trace_iscsi_aio_writev(void *iscsi, int64_t sector_num, int nb_sectors, void *opaque, void *acb) {
    if (QEMU_ISCSI_AIO_WRITEV_ENABLED()) {
        QEMU_ISCSI_AIO_WRITEV(iscsi, sector_num, nb_sectors, opaque, acb);
    }
}

static inline void trace_iscsi_aio_read10_cb(void *iscsi, int status, void *acb, int canceled) {
    if (QEMU_ISCSI_AIO_READ10_CB_ENABLED()) {
        QEMU_ISCSI_AIO_READ10_CB(iscsi, status, acb, canceled);
    }
}

static inline void trace_iscsi_aio_readv(void *iscsi, int64_t sector_num, int nb_sectors, void *opaque, void *acb) {
    if (QEMU_ISCSI_AIO_READV_ENABLED()) {
        QEMU_ISCSI_AIO_READV(iscsi, sector_num, nb_sectors, opaque, acb);
    }
}

static inline void trace_esp_raise_irq(void) {
    if (QEMU_ESP_RAISE_IRQ_ENABLED()) {
        QEMU_ESP_RAISE_IRQ();
    }
}

static inline void trace_esp_lower_irq(void) {
    if (QEMU_ESP_LOWER_IRQ_ENABLED()) {
        QEMU_ESP_LOWER_IRQ();
    }
}

static inline void trace_esp_dma_enable(void) {
    if (QEMU_ESP_DMA_ENABLE_ENABLED()) {
        QEMU_ESP_DMA_ENABLE();
    }
}

static inline void trace_esp_dma_disable(void) {
    if (QEMU_ESP_DMA_DISABLE_ENABLED()) {
        QEMU_ESP_DMA_DISABLE();
    }
}

static inline void trace_esp_get_cmd(uint32_t dmalen, int target) {
    if (QEMU_ESP_GET_CMD_ENABLED()) {
        QEMU_ESP_GET_CMD(dmalen, target);
    }
}

static inline void trace_esp_do_busid_cmd(uint8_t busid) {
    if (QEMU_ESP_DO_BUSID_CMD_ENABLED()) {
        QEMU_ESP_DO_BUSID_CMD(busid);
    }
}

static inline void trace_esp_handle_satn_stop(uint32_t cmdlen) {
    if (QEMU_ESP_HANDLE_SATN_STOP_ENABLED()) {
        QEMU_ESP_HANDLE_SATN_STOP(cmdlen);
    }
}

static inline void trace_esp_write_response(uint32_t status) {
    if (QEMU_ESP_WRITE_RESPONSE_ENABLED()) {
        QEMU_ESP_WRITE_RESPONSE(status);
    }
}

static inline void trace_esp_do_dma(uint32_t cmdlen, uint32_t len) {
    if (QEMU_ESP_DO_DMA_ENABLED()) {
        QEMU_ESP_DO_DMA(cmdlen, len);
    }
}

static inline void trace_esp_command_complete(void) {
    if (QEMU_ESP_COMMAND_COMPLETE_ENABLED()) {
        QEMU_ESP_COMMAND_COMPLETE();
    }
}

static inline void trace_esp_command_complete_unexpected(void) {
    if (QEMU_ESP_COMMAND_COMPLETE_UNEXPECTED_ENABLED()) {
        QEMU_ESP_COMMAND_COMPLETE_UNEXPECTED();
    }
}

static inline void trace_esp_command_complete_fail(void) {
    if (QEMU_ESP_COMMAND_COMPLETE_FAIL_ENABLED()) {
        QEMU_ESP_COMMAND_COMPLETE_FAIL();
    }
}

static inline void trace_esp_transfer_data(uint32_t dma_left, int32_t ti_size) {
    if (QEMU_ESP_TRANSFER_DATA_ENABLED()) {
        QEMU_ESP_TRANSFER_DATA(dma_left, ti_size);
    }
}

static inline void trace_esp_handle_ti(uint32_t minlen) {
    if (QEMU_ESP_HANDLE_TI_ENABLED()) {
        QEMU_ESP_HANDLE_TI(minlen);
    }
}

static inline void trace_esp_handle_ti_cmd(uint32_t cmdlen) {
    if (QEMU_ESP_HANDLE_TI_CMD_ENABLED()) {
        QEMU_ESP_HANDLE_TI_CMD(cmdlen);
    }
}

static inline void trace_esp_mem_readb(uint32_t saddr, uint8_t reg) {
    if (QEMU_ESP_MEM_READB_ENABLED()) {
        QEMU_ESP_MEM_READB(saddr, reg);
    }
}

static inline void trace_esp_mem_writeb(uint32_t saddr, uint8_t reg, uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_ENABLED()) {
        QEMU_ESP_MEM_WRITEB(saddr, reg, val);
    }
}

static inline void trace_esp_mem_writeb_cmd_nop(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_NOP_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_NOP(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_flush(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_FLUSH_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_FLUSH(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_reset(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_RESET_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_RESET(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_bus_reset(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_BUS_RESET_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_BUS_RESET(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_iccs(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_ICCS_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_ICCS(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_msgacc(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_MSGACC_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_MSGACC(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_pad(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_PAD_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_PAD(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_satn(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_SATN_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_SATN(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_sel(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_SEL_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_SEL(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_selatn(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_SELATN_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_SELATN(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_selatns(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_SELATNS_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_SELATNS(val);
    }
}

static inline void trace_esp_mem_writeb_cmd_ensel(uint32_t val) {
    if (QEMU_ESP_MEM_WRITEB_CMD_ENSEL_ENABLED()) {
        QEMU_ESP_MEM_WRITEB_CMD_ENSEL(val);
    }
}

static inline void trace_handle_qmp_command(void *mon, const char *cmd_name) {
    if (QEMU_HANDLE_QMP_COMMAND_ENABLED()) {
        QEMU_HANDLE_QMP_COMMAND(mon, cmd_name);
    }
}

static inline void trace_monitor_protocol_emitter(void *mon) {
    if (QEMU_MONITOR_PROTOCOL_EMITTER_ENABLED()) {
        QEMU_MONITOR_PROTOCOL_EMITTER(mon);
    }
}

static inline void trace_open_eth_mii_write(unsigned idx, uint16_t v) {
    if (QEMU_OPEN_ETH_MII_WRITE_ENABLED()) {
        QEMU_OPEN_ETH_MII_WRITE(idx, v);
    }
}

static inline void trace_open_eth_mii_read(unsigned idx, uint16_t v) {
    if (QEMU_OPEN_ETH_MII_READ_ENABLED()) {
        QEMU_OPEN_ETH_MII_READ(idx, v);
    }
}

static inline void trace_open_eth_update_irq(uint32_t v) {
    if (QEMU_OPEN_ETH_UPDATE_IRQ_ENABLED()) {
        QEMU_OPEN_ETH_UPDATE_IRQ(v);
    }
}

static inline void trace_open_eth_receive(unsigned len) {
    if (QEMU_OPEN_ETH_RECEIVE_ENABLED()) {
        QEMU_OPEN_ETH_RECEIVE(len);
    }
}

static inline void trace_open_eth_receive_mcast(unsigned idx, uint32_t h0, uint32_t h1) {
    if (QEMU_OPEN_ETH_RECEIVE_MCAST_ENABLED()) {
        QEMU_OPEN_ETH_RECEIVE_MCAST(idx, h0, h1);
    }
}

static inline void trace_open_eth_receive_reject(void) {
    if (QEMU_OPEN_ETH_RECEIVE_REJECT_ENABLED()) {
        QEMU_OPEN_ETH_RECEIVE_REJECT();
    }
}

static inline void trace_open_eth_receive_desc(uint32_t addr, uint32_t len_flags) {
    if (QEMU_OPEN_ETH_RECEIVE_DESC_ENABLED()) {
        QEMU_OPEN_ETH_RECEIVE_DESC(addr, len_flags);
    }
}

static inline void trace_open_eth_start_xmit(uint32_t addr, unsigned len, unsigned tx_len) {
    if (QEMU_OPEN_ETH_START_XMIT_ENABLED()) {
        QEMU_OPEN_ETH_START_XMIT(addr, len, tx_len);
    }
}

static inline void trace_open_eth_reg_read(uint32_t addr, uint32_t v) {
    if (QEMU_OPEN_ETH_REG_READ_ENABLED()) {
        QEMU_OPEN_ETH_REG_READ(addr, v);
    }
}

static inline void trace_open_eth_reg_write(uint32_t addr, uint32_t v) {
    if (QEMU_OPEN_ETH_REG_WRITE_ENABLED()) {
        QEMU_OPEN_ETH_REG_WRITE(addr, v);
    }
}

static inline void trace_open_eth_desc_read(uint32_t addr, uint32_t v) {
    if (QEMU_OPEN_ETH_DESC_READ_ENABLED()) {
        QEMU_OPEN_ETH_DESC_READ(addr, v);
    }
}

static inline void trace_open_eth_desc_write(uint32_t addr, uint32_t v) {
    if (QEMU_OPEN_ETH_DESC_WRITE_ENABLED()) {
        QEMU_OPEN_ETH_DESC_WRITE(addr, v);
    }
}

static inline void trace_v9fs_rerror(uint16_t tag, uint8_t id, int err) {
    if (QEMU_V9FS_RERROR_ENABLED()) {
        QEMU_V9FS_RERROR(tag, id, err);
    }
}

static inline void trace_v9fs_version(uint16_t tag, uint8_t id, int32_t msize, char* version) {
    if (QEMU_V9FS_VERSION_ENABLED()) {
        QEMU_V9FS_VERSION(tag, id, msize, version);
    }
}

static inline void trace_v9fs_version_return(uint16_t tag, uint8_t id, int32_t msize, char* version) {
    if (QEMU_V9FS_VERSION_RETURN_ENABLED()) {
        QEMU_V9FS_VERSION_RETURN(tag, id, msize, version);
    }
}

static inline void trace_v9fs_attach(uint16_t tag, uint8_t id, int32_t fid, int32_t afid, char* uname, char* aname) {
    if (QEMU_V9FS_ATTACH_ENABLED()) {
        QEMU_V9FS_ATTACH(tag, id, fid, afid, uname, aname);
    }
}

static inline void trace_v9fs_attach_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path) {
    if (QEMU_V9FS_ATTACH_RETURN_ENABLED()) {
        QEMU_V9FS_ATTACH_RETURN(tag, id, type, version, path);
    }
}

static inline void trace_v9fs_stat(uint16_t tag, uint8_t id, int32_t fid) {
    if (QEMU_V9FS_STAT_ENABLED()) {
        QEMU_V9FS_STAT(tag, id, fid);
    }
}

static inline void trace_v9fs_stat_return(uint16_t tag, uint8_t id, int32_t mode, int32_t atime, int32_t mtime, int64_t length) {
    if (QEMU_V9FS_STAT_RETURN_ENABLED()) {
        QEMU_V9FS_STAT_RETURN(tag, id, mode, atime, mtime, length);
    }
}

static inline void trace_v9fs_getattr(uint16_t tag, uint8_t id, int32_t fid, uint64_t request_mask) {
    if (QEMU_V9FS_GETATTR_ENABLED()) {
        QEMU_V9FS_GETATTR(tag, id, fid, request_mask);
    }
}

static inline void trace_v9fs_getattr_return(uint16_t tag, uint8_t id, uint64_t result_mask, uint32_t mode, uint32_t uid, uint32_t gid) {
    if (QEMU_V9FS_GETATTR_RETURN_ENABLED()) {
        QEMU_V9FS_GETATTR_RETURN(tag, id, result_mask, mode, uid, gid);
    }
}

static inline void trace_v9fs_walk(uint16_t tag, uint8_t id, int32_t fid, int32_t newfid, uint16_t nwnames) {
    if (QEMU_V9FS_WALK_ENABLED()) {
        QEMU_V9FS_WALK(tag, id, fid, newfid, nwnames);
    }
}

static inline void trace_v9fs_walk_return(uint16_t tag, uint8_t id, uint16_t nwnames, void* qids) {
    if (QEMU_V9FS_WALK_RETURN_ENABLED()) {
        QEMU_V9FS_WALK_RETURN(tag, id, nwnames, qids);
    }
}

static inline void trace_v9fs_open(uint16_t tag, uint8_t id, int32_t fid, int32_t mode) {
    if (QEMU_V9FS_OPEN_ENABLED()) {
        QEMU_V9FS_OPEN(tag, id, fid, mode);
    }
}

static inline void trace_v9fs_open_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int iounit) {
    if (QEMU_V9FS_OPEN_RETURN_ENABLED()) {
        QEMU_V9FS_OPEN_RETURN(tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_lcreate(uint16_t tag, uint8_t id, int32_t dfid, int32_t flags, int32_t mode, uint32_t gid) {
    if (QEMU_V9FS_LCREATE_ENABLED()) {
        QEMU_V9FS_LCREATE(tag, id, dfid, flags, mode, gid);
    }
}

static inline void trace_v9fs_lcreate_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int32_t iounit) {
    if (QEMU_V9FS_LCREATE_RETURN_ENABLED()) {
        QEMU_V9FS_LCREATE_RETURN(tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_fsync(uint16_t tag, uint8_t id, int32_t fid, int datasync) {
    if (QEMU_V9FS_FSYNC_ENABLED()) {
        QEMU_V9FS_FSYNC(tag, id, fid, datasync);
    }
}

static inline void trace_v9fs_clunk(uint16_t tag, uint8_t id, int32_t fid) {
    if (QEMU_V9FS_CLUNK_ENABLED()) {
        QEMU_V9FS_CLUNK(tag, id, fid);
    }
}

static inline void trace_v9fs_read(uint16_t tag, uint8_t id, int32_t fid, uint64_t off, uint32_t max_count) {
    if (QEMU_V9FS_READ_ENABLED()) {
        QEMU_V9FS_READ(tag, id, fid, off, max_count);
    }
}

static inline void trace_v9fs_read_return(uint16_t tag, uint8_t id, int32_t count, ssize_t err) {
    if (QEMU_V9FS_READ_RETURN_ENABLED()) {
        QEMU_V9FS_READ_RETURN(tag, id, count, err);
    }
}

static inline void trace_v9fs_readdir(uint16_t tag, uint8_t id, int32_t fid, uint64_t offset, uint32_t max_count) {
    if (QEMU_V9FS_READDIR_ENABLED()) {
        QEMU_V9FS_READDIR(tag, id, fid, offset, max_count);
    }
}

static inline void trace_v9fs_readdir_return(uint16_t tag, uint8_t id, uint32_t count, ssize_t retval) {
    if (QEMU_V9FS_READDIR_RETURN_ENABLED()) {
        QEMU_V9FS_READDIR_RETURN(tag, id, count, retval);
    }
}

static inline void trace_v9fs_write(uint16_t tag, uint8_t id, int32_t fid, uint64_t off, uint32_t count, int cnt) {
    if (QEMU_V9FS_WRITE_ENABLED()) {
        QEMU_V9FS_WRITE(tag, id, fid, off, count, cnt);
    }
}

static inline void trace_v9fs_write_return(uint16_t tag, uint8_t id, int32_t total, ssize_t err) {
    if (QEMU_V9FS_WRITE_RETURN_ENABLED()) {
        QEMU_V9FS_WRITE_RETURN(tag, id, total, err);
    }
}

static inline void trace_v9fs_create(uint16_t tag, uint8_t id, int32_t fid, char* name, int32_t perm, int8_t mode) {
    if (QEMU_V9FS_CREATE_ENABLED()) {
        QEMU_V9FS_CREATE(tag, id, fid, name, perm, mode);
    }
}

static inline void trace_v9fs_create_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int iounit) {
    if (QEMU_V9FS_CREATE_RETURN_ENABLED()) {
        QEMU_V9FS_CREATE_RETURN(tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_symlink(uint16_t tag, uint8_t id, int32_t fid,  char* name, char* symname, uint32_t gid) {
    if (QEMU_V9FS_SYMLINK_ENABLED()) {
        QEMU_V9FS_SYMLINK(tag, id, fid, name, symname, gid);
    }
}

static inline void trace_v9fs_symlink_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path) {
    if (QEMU_V9FS_SYMLINK_RETURN_ENABLED()) {
        QEMU_V9FS_SYMLINK_RETURN(tag, id, type, version, path);
    }
}

static inline void trace_v9fs_flush(uint16_t tag, uint8_t id, int16_t flush_tag) {
    if (QEMU_V9FS_FLUSH_ENABLED()) {
        QEMU_V9FS_FLUSH(tag, id, flush_tag);
    }
}

static inline void trace_v9fs_link(uint16_t tag, uint8_t id, int32_t dfid, int32_t oldfid, char* name) {
    if (QEMU_V9FS_LINK_ENABLED()) {
        QEMU_V9FS_LINK(tag, id, dfid, oldfid, name);
    }
}

static inline void trace_v9fs_remove(uint16_t tag, uint8_t id, int32_t fid) {
    if (QEMU_V9FS_REMOVE_ENABLED()) {
        QEMU_V9FS_REMOVE(tag, id, fid);
    }
}

static inline void trace_v9fs_wstat(uint16_t tag, uint8_t id, int32_t fid, int32_t mode, int32_t atime, int32_t mtime) {
    if (QEMU_V9FS_WSTAT_ENABLED()) {
        QEMU_V9FS_WSTAT(tag, id, fid, mode, atime, mtime);
    }
}

static inline void trace_v9fs_mknod(uint16_t tag, uint8_t id, int32_t fid, int mode, int major, int minor) {
    if (QEMU_V9FS_MKNOD_ENABLED()) {
        QEMU_V9FS_MKNOD(tag, id, fid, mode, major, minor);
    }
}

static inline void trace_v9fs_mknod_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path) {
    if (QEMU_V9FS_MKNOD_RETURN_ENABLED()) {
        QEMU_V9FS_MKNOD_RETURN(tag, id, type, version, path);
    }
}

static inline void trace_v9fs_lock(uint16_t tag, uint8_t id, int32_t fid, uint8_t type, uint64_t start, uint64_t length) {
    if (QEMU_V9FS_LOCK_ENABLED()) {
        QEMU_V9FS_LOCK(tag, id, fid, type, start, length);
    }
}

static inline void trace_v9fs_lock_return(uint16_t tag, uint8_t id, int8_t status) {
    if (QEMU_V9FS_LOCK_RETURN_ENABLED()) {
        QEMU_V9FS_LOCK_RETURN(tag, id, status);
    }
}

static inline void trace_v9fs_getlock(uint16_t tag, uint8_t id, int32_t fid, uint8_t type, uint64_t start, uint64_t length) {
    if (QEMU_V9FS_GETLOCK_ENABLED()) {
        QEMU_V9FS_GETLOCK(tag, id, fid, type, start, length);
    }
}

static inline void trace_v9fs_getlock_return(uint16_t tag, uint8_t id, uint8_t type, uint64_t start, uint64_t length, uint32_t proc_id) {
    if (QEMU_V9FS_GETLOCK_RETURN_ENABLED()) {
        QEMU_V9FS_GETLOCK_RETURN(tag, id, type, start, length, proc_id);
    }
}

static inline void trace_v9fs_mkdir(uint16_t tag, uint8_t id, int32_t fid, char* name, int mode, uint32_t gid) {
    if (QEMU_V9FS_MKDIR_ENABLED()) {
        QEMU_V9FS_MKDIR(tag, id, fid, name, mode, gid);
    }
}

static inline void trace_v9fs_mkdir_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int err) {
    if (QEMU_V9FS_MKDIR_RETURN_ENABLED()) {
        QEMU_V9FS_MKDIR_RETURN(tag, id, type, version, path, err);
    }
}

static inline void trace_v9fs_xattrwalk(uint16_t tag, uint8_t id, int32_t fid, int32_t newfid, char* name) {
    if (QEMU_V9FS_XATTRWALK_ENABLED()) {
        QEMU_V9FS_XATTRWALK(tag, id, fid, newfid, name);
    }
}

static inline void trace_v9fs_xattrwalk_return(uint16_t tag, uint8_t id, int64_t size) {
    if (QEMU_V9FS_XATTRWALK_RETURN_ENABLED()) {
        QEMU_V9FS_XATTRWALK_RETURN(tag, id, size);
    }
}

static inline void trace_v9fs_xattrcreate(uint16_t tag, uint8_t id, int32_t fid, char* name, int64_t size, int flags) {
    if (QEMU_V9FS_XATTRCREATE_ENABLED()) {
        QEMU_V9FS_XATTRCREATE(tag, id, fid, name, size, flags);
    }
}

static inline void trace_v9fs_readlink(uint16_t tag, uint8_t id, int32_t fid) {
    if (QEMU_V9FS_READLINK_ENABLED()) {
        QEMU_V9FS_READLINK(tag, id, fid);
    }
}

static inline void trace_v9fs_readlink_return(uint16_t tag, uint8_t id, char* target) {
    if (QEMU_V9FS_READLINK_RETURN_ENABLED()) {
        QEMU_V9FS_READLINK_RETURN(tag, id, target);
    }
}

static inline void trace_mmu_helper_dfault(uint64_t address, uint64_t context, int mmu_idx, uint32_t tl) {
    if (QEMU_MMU_HELPER_DFAULT_ENABLED()) {
        QEMU_MMU_HELPER_DFAULT(address, context, mmu_idx, tl);
    }
}

static inline void trace_mmu_helper_dprot(uint64_t address, uint64_t context, int mmu_idx, uint32_t tl) {
    if (QEMU_MMU_HELPER_DPROT_ENABLED()) {
        QEMU_MMU_HELPER_DPROT(address, context, mmu_idx, tl);
    }
}

static inline void trace_mmu_helper_dmiss(uint64_t address, uint64_t context) {
    if (QEMU_MMU_HELPER_DMISS_ENABLED()) {
        QEMU_MMU_HELPER_DMISS(address, context);
    }
}

static inline void trace_mmu_helper_tfault(uint64_t address, uint64_t context) {
    if (QEMU_MMU_HELPER_TFAULT_ENABLED()) {
        QEMU_MMU_HELPER_TFAULT(address, context);
    }
}

static inline void trace_mmu_helper_tmiss(uint64_t address, uint64_t context) {
    if (QEMU_MMU_HELPER_TMISS_ENABLED()) {
        QEMU_MMU_HELPER_TMISS(address, context);
    }
}

static inline void trace_mmu_helper_get_phys_addr_code(uint32_t tl, int mmu_idx, uint64_t prim_context, uint64_t sec_context, uint64_t address) {
    if (QEMU_MMU_HELPER_GET_PHYS_ADDR_CODE_ENABLED()) {
        QEMU_MMU_HELPER_GET_PHYS_ADDR_CODE(tl, mmu_idx, prim_context, sec_context, address);
    }
}

static inline void trace_mmu_helper_get_phys_addr_data(uint32_t tl, int mmu_idx, uint64_t prim_context, uint64_t sec_context, uint64_t address) {
    if (QEMU_MMU_HELPER_GET_PHYS_ADDR_DATA_ENABLED()) {
        QEMU_MMU_HELPER_GET_PHYS_ADDR_DATA(tl, mmu_idx, prim_context, sec_context, address);
    }
}

static inline void trace_mmu_helper_mmu_fault(uint64_t address, uint64_t paddr, int mmu_idx, uint32_t tl, uint64_t prim_context, uint64_t sec_context) {
    if (QEMU_MMU_HELPER_MMU_FAULT_ENABLED()) {
        QEMU_MMU_HELPER_MMU_FAULT(address, paddr, mmu_idx, tl, prim_context, sec_context);
    }
}

static inline void trace_int_helper_set_softint(uint32_t softint) {
    if (QEMU_INT_HELPER_SET_SOFTINT_ENABLED()) {
        QEMU_INT_HELPER_SET_SOFTINT(softint);
    }
}

static inline void trace_int_helper_clear_softint(uint32_t softint) {
    if (QEMU_INT_HELPER_CLEAR_SOFTINT_ENABLED()) {
        QEMU_INT_HELPER_CLEAR_SOFTINT(softint);
    }
}

static inline void trace_int_helper_write_softint(uint32_t softint) {
    if (QEMU_INT_HELPER_WRITE_SOFTINT_ENABLED()) {
        QEMU_INT_HELPER_WRITE_SOFTINT(softint);
    }
}

static inline void trace_int_helper_icache_freeze(void) {
    if (QEMU_INT_HELPER_ICACHE_FREEZE_ENABLED()) {
        QEMU_INT_HELPER_ICACHE_FREEZE();
    }
}

static inline void trace_int_helper_dcache_freeze(void) {
    if (QEMU_INT_HELPER_DCACHE_FREEZE_ENABLED()) {
        QEMU_INT_HELPER_DCACHE_FREEZE();
    }
}

static inline void trace_win_helper_gregset_error(uint32_t pstate) {
    if (QEMU_WIN_HELPER_GREGSET_ERROR_ENABLED()) {
        QEMU_WIN_HELPER_GREGSET_ERROR(pstate);
    }
}

static inline void trace_win_helper_switch_pstate(uint32_t pstate_regs, uint32_t new_pstate_regs) {
    if (QEMU_WIN_HELPER_SWITCH_PSTATE_ENABLED()) {
        QEMU_WIN_HELPER_SWITCH_PSTATE(pstate_regs, new_pstate_regs);
    }
}

static inline void trace_win_helper_no_switch_pstate(uint32_t new_pstate_regs) {
    if (QEMU_WIN_HELPER_NO_SWITCH_PSTATE_ENABLED()) {
        QEMU_WIN_HELPER_NO_SWITCH_PSTATE(new_pstate_regs);
    }
}

static inline void trace_win_helper_wrpil(uint32_t psrpil, uint32_t new_pil) {
    if (QEMU_WIN_HELPER_WRPIL_ENABLED()) {
        QEMU_WIN_HELPER_WRPIL(psrpil, new_pil);
    }
}

static inline void trace_win_helper_done(uint32_t tl) {
    if (QEMU_WIN_HELPER_DONE_ENABLED()) {
        QEMU_WIN_HELPER_DONE(tl);
    }
}

static inline void trace_win_helper_retry(uint32_t tl) {
    if (QEMU_WIN_HELPER_RETRY_ENABLED()) {
        QEMU_WIN_HELPER_RETRY(tl);
    }
}

static inline void trace_qxl_interface_set_mm_time(int qid, uint32_t mm_time)
{
}

static inline void trace_qxl_io_write_vga(int qid, const char *mode, uint32_t addr, uint32_t val)
{
}

static inline void trace_qxl_create_guest_primary(int qid, uint32_t width, uint32_t height, uint64_t mem, uint32_t format, uint32_t position) {
    if (QEMU_QXL_CREATE_GUEST_PRIMARY_ENABLED()) {
        QEMU_QXL_CREATE_GUEST_PRIMARY(qid, width, height, mem, format, position);
    }
}

static inline void trace_qxl_create_guest_primary_rest(int qid, int32_t stride, uint32_t type, uint32_t flags) {
    if (QEMU_QXL_CREATE_GUEST_PRIMARY_REST_ENABLED()) {
        QEMU_QXL_CREATE_GUEST_PRIMARY_REST(qid, stride, type, flags);
    }
}

static inline void trace_qxl_destroy_primary(int qid) {
    if (QEMU_QXL_DESTROY_PRIMARY_ENABLED()) {
        QEMU_QXL_DESTROY_PRIMARY(qid);
    }
}

static inline void trace_qxl_enter_vga_mode(int qid) {
    if (QEMU_QXL_ENTER_VGA_MODE_ENABLED()) {
        QEMU_QXL_ENTER_VGA_MODE(qid);
    }
}

static inline void trace_qxl_exit_vga_mode(int qid) {
    if (QEMU_QXL_EXIT_VGA_MODE_ENABLED()) {
        QEMU_QXL_EXIT_VGA_MODE(qid);
    }
}

static inline void trace_qxl_hard_reset(int qid, int64_t loadvm) {
    if (QEMU_QXL_HARD_RESET_ENABLED()) {
        QEMU_QXL_HARD_RESET(qid, loadvm);
    }
}

static inline void trace_qxl_interface_async_complete_io(int qid, uint32_t current_async, void *cookie) {
    if (QEMU_QXL_INTERFACE_ASYNC_COMPLETE_IO_ENABLED()) {
        QEMU_QXL_INTERFACE_ASYNC_COMPLETE_IO(qid, current_async, cookie);
    }
}

static inline void trace_qxl_interface_attach_worker(int qid) {
    if (QEMU_QXL_INTERFACE_ATTACH_WORKER_ENABLED()) {
        QEMU_QXL_INTERFACE_ATTACH_WORKER(qid);
    }
}

static inline void trace_qxl_interface_get_init_info(int qid) {
    if (QEMU_QXL_INTERFACE_GET_INIT_INFO_ENABLED()) {
        QEMU_QXL_INTERFACE_GET_INIT_INFO(qid);
    }
}

static inline void trace_qxl_interface_set_compression_level(int qid, int64_t level) {
    if (QEMU_QXL_INTERFACE_SET_COMPRESSION_LEVEL_ENABLED()) {
        QEMU_QXL_INTERFACE_SET_COMPRESSION_LEVEL(qid, level);
    }
}

static inline void trace_qxl_interface_update_area_complete(int qid, uint32_t surface_id, uint32_t dirty_left, uint32_t dirty_right, uint32_t dirty_top, uint32_t dirty_bottom) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE(qid, surface_id, dirty_left, dirty_right, dirty_top, dirty_bottom);
    }
}

static inline void trace_qxl_interface_update_area_complete_rest(int qid, uint32_t num_updated_rects) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST(qid, num_updated_rects);
    }
}

static inline void trace_qxl_interface_update_area_complete_overflow(int qid, int max) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW(qid, max);
    }
}

static inline void trace_qxl_interface_update_area_complete_schedule_bh(int qid, uint32_t num_dirty) {
    if (QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH_ENABLED()) {
        QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH(qid, num_dirty);
    }
}

static inline void trace_qxl_io_destroy_primary_ignored(int qid, const char *mode) {
    if (QEMU_QXL_IO_DESTROY_PRIMARY_IGNORED_ENABLED()) {
        QEMU_QXL_IO_DESTROY_PRIMARY_IGNORED(qid, mode);
    }
}

static inline void trace_qxl_io_read_unexpected(int qid) {
    if (QEMU_QXL_IO_READ_UNEXPECTED_ENABLED()) {
        QEMU_QXL_IO_READ_UNEXPECTED(qid);
    }
}

static inline void trace_qxl_io_unexpected_vga_mode(int qid, uint32_t io_port, const char *desc) {
    if (QEMU_QXL_IO_UNEXPECTED_VGA_MODE_ENABLED()) {
        QEMU_QXL_IO_UNEXPECTED_VGA_MODE(qid, io_port, desc);
    }
}

static inline void trace_qxl_io_write(int qid, const char *mode, uint64_t addr, uint64_t val, unsigned size, int async) {
    if (QEMU_QXL_IO_WRITE_ENABLED()) {
        QEMU_QXL_IO_WRITE(qid, mode, addr, val, size, async);
    }
}

static inline void trace_qxl_memslot_add_guest(int qid, uint32_t slot_id, uint64_t guest_start, uint64_t guest_end) {
    if (QEMU_QXL_MEMSLOT_ADD_GUEST_ENABLED()) {
        QEMU_QXL_MEMSLOT_ADD_GUEST(qid, slot_id, guest_start, guest_end);
    }
}

static inline void trace_qxl_post_load(int qid, const char *mode) {
    if (QEMU_QXL_POST_LOAD_ENABLED()) {
        QEMU_QXL_POST_LOAD(qid, mode);
    }
}

static inline void trace_qxl_pre_load(int qid) {
    if (QEMU_QXL_PRE_LOAD_ENABLED()) {
        QEMU_QXL_PRE_LOAD(qid);
    }
}

static inline void trace_qxl_pre_save(int qid) {
    if (QEMU_QXL_PRE_SAVE_ENABLED()) {
        QEMU_QXL_PRE_SAVE(qid);
    }
}

static inline void trace_qxl_reset_surfaces(int qid) {
    if (QEMU_QXL_RESET_SURFACES_ENABLED()) {
        QEMU_QXL_RESET_SURFACES(qid);
    }
}

static inline void trace_qxl_ring_command_check(int qid, const char *mode) {
    if (QEMU_QXL_RING_COMMAND_CHECK_ENABLED()) {
        QEMU_QXL_RING_COMMAND_CHECK(qid, mode);
    }
}

static inline void trace_qxl_ring_command_get(int qid, const char *mode) {
    if (QEMU_QXL_RING_COMMAND_GET_ENABLED()) {
        QEMU_QXL_RING_COMMAND_GET(qid, mode);
    }
}

static inline void trace_qxl_ring_command_req_notification(int qid) {
    if (QEMU_QXL_RING_COMMAND_REQ_NOTIFICATION_ENABLED()) {
        QEMU_QXL_RING_COMMAND_REQ_NOTIFICATION(qid);
    }
}

static inline void trace_qxl_ring_cursor_check(int qid, const char *mode) {
    if (QEMU_QXL_RING_CURSOR_CHECK_ENABLED()) {
        QEMU_QXL_RING_CURSOR_CHECK(qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_get(int qid, const char *mode) {
    if (QEMU_QXL_RING_CURSOR_GET_ENABLED()) {
        QEMU_QXL_RING_CURSOR_GET(qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_req_notification(int qid) {
    if (QEMU_QXL_RING_CURSOR_REQ_NOTIFICATION_ENABLED()) {
        QEMU_QXL_RING_CURSOR_REQ_NOTIFICATION(qid);
    }
}

static inline void trace_qxl_ring_res_push(int qid, const char *mode, uint32_t surface_count, uint32_t free_res, void *last_release, const char *notify) {
    if (QEMU_QXL_RING_RES_PUSH_ENABLED()) {
        QEMU_QXL_RING_RES_PUSH(qid, mode, surface_count, free_res, last_release, notify);
    }
}

static inline void trace_qxl_ring_res_push_rest(int qid, uint32_t ring_has, uint32_t ring_size, uint32_t prod, uint32_t cons) {
    if (QEMU_QXL_RING_RES_PUSH_REST_ENABLED()) {
        QEMU_QXL_RING_RES_PUSH_REST(qid, ring_has, ring_size, prod, cons);
    }
}

static inline void trace_qxl_ring_res_put(int qid, uint32_t free_res) {
    if (QEMU_QXL_RING_RES_PUT_ENABLED()) {
        QEMU_QXL_RING_RES_PUT(qid, free_res);
    }
}

static inline void trace_qxl_set_mode(int qid, int modenr, uint32_t x_res, uint32_t y_res, uint32_t bits, uint64_t devmem) {
    if (QEMU_QXL_SET_MODE_ENABLED()) {
        QEMU_QXL_SET_MODE(qid, modenr, x_res, y_res, bits, devmem);
    }
}

static inline void trace_qxl_soft_reset(int qid) {
    if (QEMU_QXL_SOFT_RESET_ENABLED()) {
        QEMU_QXL_SOFT_RESET(qid);
    }
}

static inline void trace_qemu_spice_add_memslot(int qid, uint32_t slot_id, unsigned long virt_start, unsigned long virt_end, int async) {
    if (QEMU_QEMU_SPICE_ADD_MEMSLOT_ENABLED()) {
        QEMU_QEMU_SPICE_ADD_MEMSLOT(qid, slot_id, virt_start, virt_end, async);
    }
}

static inline void trace_qemu_spice_del_memslot(int qid, uint32_t gid, uint32_t slot_id) {
    if (QEMU_QEMU_SPICE_DEL_MEMSLOT_ENABLED()) {
        QEMU_QEMU_SPICE_DEL_MEMSLOT(qid, gid, slot_id);
    }
}

static inline void trace_qemu_spice_create_primary_surface(int qid, uint32_t sid, void *surface, int async) {
    if (QEMU_QEMU_SPICE_CREATE_PRIMARY_SURFACE_ENABLED()) {
        QEMU_QEMU_SPICE_CREATE_PRIMARY_SURFACE(qid, sid, surface, async);
    }
}

static inline void trace_qemu_spice_destroy_primary_surface(int qid, uint32_t sid, int async) {
    if (QEMU_QEMU_SPICE_DESTROY_PRIMARY_SURFACE_ENABLED()) {
        QEMU_QEMU_SPICE_DESTROY_PRIMARY_SURFACE(qid, sid, async);
    }
}

static inline void trace_qemu_spice_wakeup(uint32_t qid) {
    if (QEMU_QEMU_SPICE_WAKEUP_ENABLED()) {
        QEMU_QEMU_SPICE_WAKEUP(qid);
    }
}

static inline void trace_qemu_spice_start(uint32_t qid) {
    if (QEMU_QEMU_SPICE_START_ENABLED()) {
        QEMU_QEMU_SPICE_START(qid);
    }
}

static inline void trace_qemu_spice_stop(uint32_t qid) {
    if (QEMU_QEMU_SPICE_STOP_ENABLED()) {
        QEMU_QEMU_SPICE_STOP(qid);
    }
}

static inline void trace_qemu_spice_create_update(uint32_t left, uint32_t right, uint32_t top, uint32_t bottom) {
    if (QEMU_QEMU_SPICE_CREATE_UPDATE_ENABLED()) {
        QEMU_QEMU_SPICE_CREATE_UPDATE(left, right, top, bottom);
    }
}

static inline void trace_qxl_spice_destroy_surfaces_complete(int qid) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACES_COMPLETE_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACES_COMPLETE(qid);
    }
}

static inline void trace_qxl_spice_destroy_surfaces(int qid, int async) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACES_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACES(qid, async);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait_complete(int qid, uint32_t id) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE(qid, id);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait(int qid, uint32_t id, int async) {
    if (QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_ENABLED()) {
        QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT(qid, id, async);
    }
}

static inline void trace_qxl_spice_flush_surfaces_async(int qid, uint32_t surface_count, uint32_t num_free_res) {
    if (QEMU_QXL_SPICE_FLUSH_SURFACES_ASYNC_ENABLED()) {
        QEMU_QXL_SPICE_FLUSH_SURFACES_ASYNC(qid, surface_count, num_free_res);
    }
}

static inline void trace_qxl_spice_loadvm_commands(int qid, void *ext, uint32_t count) {
    if (QEMU_QXL_SPICE_LOADVM_COMMANDS_ENABLED()) {
        QEMU_QXL_SPICE_LOADVM_COMMANDS(qid, ext, count);
    }
}

static inline void trace_qxl_spice_oom(int qid) {
    if (QEMU_QXL_SPICE_OOM_ENABLED()) {
        QEMU_QXL_SPICE_OOM(qid);
    }
}

static inline void trace_qxl_spice_reset_cursor(int qid) {
    if (QEMU_QXL_SPICE_RESET_CURSOR_ENABLED()) {
        QEMU_QXL_SPICE_RESET_CURSOR(qid);
    }
}

static inline void trace_qxl_spice_reset_image_cache(int qid) {
    if (QEMU_QXL_SPICE_RESET_IMAGE_CACHE_ENABLED()) {
        QEMU_QXL_SPICE_RESET_IMAGE_CACHE(qid);
    }
}

static inline void trace_qxl_spice_reset_memslots(int qid) {
    if (QEMU_QXL_SPICE_RESET_MEMSLOTS_ENABLED()) {
        QEMU_QXL_SPICE_RESET_MEMSLOTS(qid);
    }
}

static inline void trace_qxl_spice_update_area(int qid, uint32_t surface_id, uint32_t left, uint32_t right, uint32_t top, uint32_t bottom) {
    if (QEMU_QXL_SPICE_UPDATE_AREA_ENABLED()) {
        QEMU_QXL_SPICE_UPDATE_AREA(qid, surface_id, left, right, top, bottom);
    }
}

static inline void trace_qxl_spice_update_area_rest(int qid, uint32_t num_dirty_rects, uint32_t clear_dirty_region) {
    if (QEMU_QXL_SPICE_UPDATE_AREA_REST_ENABLED()) {
        QEMU_QXL_SPICE_UPDATE_AREA_REST(qid, num_dirty_rects, clear_dirty_region);
    }
}

static inline void trace_qxl_surfaces_dirty(int qid, int surface, int offset, int size) {
    if (QEMU_QXL_SURFACES_DIRTY_ENABLED()) {
        QEMU_QXL_SURFACES_DIRTY(qid, surface, offset, size);
    }
}

static inline void trace_qxl_vga_ioport_while_not_in_vga_mode(int qid) {
    if (QEMU_QXL_VGA_IOPORT_WHILE_NOT_IN_VGA_MODE_ENABLED()) {
        QEMU_QXL_VGA_IOPORT_WHILE_NOT_IN_VGA_MODE(qid);
    }
}

static inline void trace_qxl_render_blit_guest_primary_initialized(void) {
    if (QEMU_QXL_RENDER_BLIT_GUEST_PRIMARY_INITIALIZED_ENABLED()) {
        QEMU_QXL_RENDER_BLIT_GUEST_PRIMARY_INITIALIZED();
    }
}

static inline void trace_qxl_render_blit(int32_t stride, int32_t left, int32_t right, int32_t top, int32_t bottom) {
    if (QEMU_QXL_RENDER_BLIT_ENABLED()) {
        QEMU_QXL_RENDER_BLIT(stride, left, right, top, bottom);
    }
}

static inline void trace_qxl_render_guest_primary_resized(int32_t width, int32_t height, int32_t stride, int32_t bytes_pp, int32_t bits_pp) {
    if (QEMU_QXL_RENDER_GUEST_PRIMARY_RESIZED_ENABLED()) {
        QEMU_QXL_RENDER_GUEST_PRIMARY_RESIZED(width, height, stride, bytes_pp, bits_pp);
    }
}

static inline void trace_qxl_render_update_area_done(void *cookie) {
    if (QEMU_QXL_RENDER_UPDATE_AREA_DONE_ENABLED()) {
        QEMU_QXL_RENDER_UPDATE_AREA_DONE(cookie);
    }
}

#endif /* TRACE_H */
